<?php
defined( 'ABSPATH' ) OR exit;
/**
 * 
 *
 * @author Zishan J.
 */
class GI_Catalog_ManageCatalogs {

    private $error = "";
    private $success = "";
    private $menus_tabs = array();
    private $menus_managecategories_key = "manage_categories";
    private $menus_import_key = "import";
    private $menus_about_key = "about";
    private $menus_settings_key = "settings";
    private $menus_key = "gi-catalog";
    private $current_tab;

    function __construct() {
        include(GICATALOG_INCLUDES . 'base/GI_Catalog_View.php');

        //$this->menus_tabs[$this->menus_overview_key] = "Overview";
        $this->menus_tabs[$this->menus_managecategories_key] = "Manage Categories";
        //$this->menus_tabs[$this->menus_import_key] = "Import";
        $this->menus_tabs[$this->menus_settings_key] = "Settings";
        $this->menus_tabs["separator1"] = "";
        $this->menus_tabs["separator2"] = "";
        $this->menus_tabs[$this->menus_about_key] = "About";

        $this->current_tab = isset($_GET['tab']) ? $_GET['tab'] : $this->menus_managecategories_key;
        $_GET['tab'] = $this->current_tab;
        
        add_action( 'admin_footer', array( __CLASS__, 'init_wp_editor') );
        
    }

    function gicatalog_managecatalogs_tabs() {
        
        echo '<h2 class="nav-tab-wrapper">GI-Catalog<span class="separator"></span>';
        foreach ($this->menus_tabs as $tab_key => $tab_caption) {
            if (strpos($tab_key, 'separator')===false) {
                $active = $this->current_tab == $tab_key ? 'nav-tab-active' : '';
                echo '<a class="nav-tab ' . $active . '" href="?page=' . $this->menus_key . '&tab=' . $tab_key . '">' . $tab_caption . '</a>';
            } else {
                echo '<span class="separator"></span>';
            }
        }
        echo '</h2>';
        echo '<br/>';

        switch ($this->current_tab) {
            /*case $this->menus_overview_key:


                break;*/
            case $this->menus_managecategories_key:
                $this->page_managecategories();
                break;
            case $this->menus_import_key:
                $this->page_import();
                break;
            case $this->menus_about_key:
                $this->page_about();
                break;
            case $this->menus_settings_key:
                $this->page_settings();
                break;
            default:
                break;
        }
    }
    
    private function page_about() {
        wp_enqueue_script('postbox');
        wp_enqueue_script('jquery-ui-dialog');
        wp_enqueue_script('jquery-scrollto', GICATALOG_URI . 'includes/views/admin/js/vendors/jquery.scrollTo.min.js');
        wp_enqueue_script('angularjs', GICATALOG_URI . 'js/angular.min.js');
        wp_enqueue_script('angularjs-animate', GICATALOG_URI . 'js/angular-animate.min.js');
        wp_enqueue_script('angularjs-bindonce', GICATALOG_URI . 'js/angular-bindonce.min.js');
        //having conflict with underscore used by WP Media Library
        wp_enqueue_script('lodash', GICATALOG_URI . 'js/lodash.min.js');
        
        wp_enqueue_script('admin-app', GICATALOG_URI . 'includes/views/admin/js/app.js');
        wp_localize_script( 'admin-app', 'catalogData',
                ['URI' => GICATALOG_URI,
                'nonce' => GICATALOG_NONCE,
                'ajax_url' => admin_url( 'admin-ajax.php' )]);
        
        wp_enqueue_script('about-controller', GICATALOG_URI . 'includes/views/admin/js/controllers/about.js');
        
        wp_enqueue_style('jquery-ui-css', GICATALOG_URI . 'css/smoothness/jquery-ui-1.10.4.custom.min.css');
        wp_enqueue_style('gicatalog-admin-style', GICATALOG_URI . 'includes/views/admin/css/admin.css');
        
        $view = new GI_Catalog_View("admin/about");
        //$view->set("categories", $cat->get_categories());
        //$view->set("menu", (isset($_POST['menu'])) ? $_POST['menu'] : 'groups');
        
        $view->render();
    }
    
    private function page_import() {
        
        $view = new GI_Catalog_View("admin/import");
        //$view->set("categories", $cat->get_categories());
        //$view->set("menu", (isset($_POST['menu'])) ? $_POST['menu'] : 'groups');
        
        $view->render();
    }
    
    private function page_settings() {
        wp_enqueue_script('jquery-scrollto', GICATALOG_URI . 'includes/views/admin/js/vendors/jquery.scrollTo.min.js');
        //wp_enqueue_script('jquery.validation', GIRESTT_URI . 'js/jquery.validate.min.js');
        wp_enqueue_script('angularjs', GICATALOG_URI . 'js/angular.min.js');
        wp_enqueue_script('angularjs-animate', GICATALOG_URI . 'js/angular-animate.min.js');
        wp_enqueue_script('angularjs-bindonce', GICATALOG_URI . 'js/angular-bindonce.min.js');
        //having conflict with underscore used by WP Media Library
        wp_enqueue_script('lodash', GICATALOG_URI . 'js/lodash.min.js');
        
        wp_enqueue_script('admin-app', GICATALOG_URI . 'includes/views/admin/js/app.js');
        
        wp_localize_script( 'admin-app', 'catalogData',
                ['URI' => GICATALOG_URI,
                'nonce' => GICATALOG_NONCE,
                'ajax_url' => admin_url( 'admin-ajax.php' ),
                'disable_jqueryui_css' => get_site_option('gicatalog_disable_jqueryui_css'),
                'disable_bootstrap_css' => get_site_option("gicatalog_disable_bootstrap_css"),
                'fb_app_id' => get_site_option('gicatalog_fb_app_id'),
                'fb_media_type' => get_site_option('gicatalog_fb_media_type'),
                'fb_image' => get_site_option('gicatalog_fb_image'),
				'email_from' => stripslashes(get_site_option('gicatalog_email_from')),
				'email_address' => get_site_option('gicatalog_email_address'),
                'email_subject' => stripslashes(get_site_option('gicatalog_email_subject')),
                'email_template' => stripslashes(get_site_option('gicatalog_email_template'))]);
        
        wp_enqueue_script('about-controller', GICATALOG_URI . 'includes/views/admin/js/controllers/settings.js');
        
        wp_enqueue_script('jquery-ui-dialog');
        wp_enqueue_style('jquery-ui-css', GICATALOG_URI . 'css/smoothness/jquery-ui-1.10.4.custom.min.css');
        wp_enqueue_style('gicatalog-admin-style', GICATALOG_URI . 'includes/views/admin/css/admin.css');
        
        $view = new GI_Catalog_View("admin/settings");
        //$view->set("categories", $cat->get_categories());
        //$view->set("menu", (isset($_POST['menu'])) ? $_POST['menu'] : 'groups');
        
        $view->render();
    }

    private function page_managecategories() {
        wp_enqueue_script('accordion');
        wp_enqueue_script('jquery-ui-position');
        wp_enqueue_script('jquery.menu', GICATALOG_URI . 'js/jquery.ui.menu.min.js');
        wp_enqueue_script('jquery-scrollto', GICATALOG_URI . 'includes/views/admin/js/vendors/jquery.scrollTo.min.js');
        //wp_enqueue_script('jquery.validation', GIRESTT_URI . 'js/jquery.validate.min.js');
        wp_enqueue_script('angularjs', GICATALOG_URI . 'js/angular.min.js');
        wp_enqueue_script('angularjs-animate', GICATALOG_URI . 'js/angular-animate.min.js');
        wp_enqueue_script('angularjs-bindonce', GICATALOG_URI . 'js/angular-bindonce.min.js');
        //having conflict with underscore used by WP Media Library
        wp_enqueue_script('lodash', GICATALOG_URI . 'js/lodash.min.js');
        
        wp_enqueue_script('admin-app', GICATALOG_URI . 'includes/views/admin/js/app.js');
        
        wp_localize_script( 'admin-app', 'catalogData',
                ['URI' => GICATALOG_URI,
                'nonce' => GICATALOG_NONCE,
                'ajax_url' => admin_url( 'admin-ajax.php' )]);
        
        wp_enqueue_script('admin-app-cmp-accordion', GICATALOG_URI . 'includes/views/admin/js/components/accordion.js');
        wp_enqueue_script('admin-app-cmp-tab', GICATALOG_URI . 'includes/views/admin/js/components/tab.js');
        wp_enqueue_script('admin-app-cmp-texteditor', GICATALOG_URI . 'includes/views/admin/js/components/texteditor.js');
        
        wp_enqueue_script('groups-controller', GICATALOG_URI . 'includes/views/admin/js/controllers/groups.js');
        wp_enqueue_script('categories-controller', GICATALOG_URI . 'includes/views/admin/js/controllers/categories.js');
        
        $group = new GI_Catalog_Group();
        
        wp_localize_script( 'groups-controller', 'groupData',
                ['nonce' => GICATALOG_NONCE,
                'groups' => $group->get()] );//admin_url( 'admin-ajax.php' )
        
        $category = new GI_Catalog_Category();
        wp_localize_script( 'categories-controller', 'categoryData',
                ['nonce' => GICATALOG_NONCE,
                'groups' => $group->get(),
                'categories' => $category->get(false, null, $group->get()[0]['groupid'])] );
        
        wp_enqueue_script('jquery-ui-dialog');
        wp_enqueue_script('jquery-ui-tabs');
        wp_enqueue_script('jquery-ui-accordion');
        wp_enqueue_style('jquery-ui-css', GICATALOG_URI . 'css/smoothness/jquery-ui-1.10.4.custom.min.css');
        wp_enqueue_style('gicatalog-admin-style', GICATALOG_URI . 'includes/views/admin/css/admin.css');

        add_thickbox();
        
        $this->print_error();
        $this->print_success();

        //$cat = new GI_Catalog_Category();
        
        $view = new GI_Catalog_View("admin/managecategories");
        //$view->set("categories", $cat->get_categories());
        $view->set("menu", (isset($_POST['menu'])) ? $_POST['menu'] : 'groups');
        
        
        
        $view->render();
        
    }

    public static function init_wp_editor()
    {
	$output = '<div style="display:none;">';
        ob_start();
	wp_editor( '', 'content', ['dfw' => false,
                'drag_drop_upload' => true,
                'wpautop' => true,
                'tabfocus_elements' => 'insert-media-button,save-post'] );
        $output .= ob_get_contents();
        ob_end_clean();
        $output .= '</div>';
        echo $output;
    }
    
    private function check_error($data, $custom_msg = "") {
        if (is_wp_error($data)) {
            $this->error .= "<b>ERROR:</b> " . ((!empty($custom_msg)) ? $custom_msg : $data->get_error_message()) . "<br />";
            return false;
        }
        return true;
    }

    private function print_error() {
        if (!empty($this->error))
            echo '<div class="error"><p>' . $this->error . '</p></div>';

        $this->error = "";
    }

    private function print_success() {
        if (!empty($this->success))
            echo '<div class="updated"><p>' . $this->success . '</p></div>';

        $this->success = "";
    }

}

?>
