<!--

@author Zishan J.

-->

<script>
    jQuery(function($) {
        $.showStatusDialog = function(options) {
            var defaults = {
                showImage: true,
                show: true,
                message: ''
            };
            var merged_options = $.extend({}, defaults, options);

            if (merged_options.showImage) {
                $('div#statusdialog').find('img').show();
            } else {
                $('div#statusdialog').find('img').hide();
            }
            if (merged_options.message != '') {
                $('div#statusdialog').find('span').html(merged_options.message);
            }
            if (merged_options.show) {
                $('div#statusdialog').dialog('open');
            } else {
                setTimeout(function() {
                    $('div#statusdialog').dialog('close');
                }, 1000);
            }
        };
        $('div#statusdialog').dialog({
            draggable: false,
            resizable: false,
            modal: true,
            minWidth: false,
            minHeight: false,
            width: "auto",
            autoOpen: false
        });
        $(".ui-dialog-titlebar").hide();
        $(window).resize(function() {
            $("div#statusdialog").dialog("option", "position", "center");
        });

    });
</script>
<div ng-app="GI-Catalog">
    <div class="clear"></div>
    <div id="statusdialog" style="-webkit-box-shadow: 2px 2px 5px #888; -moz-box-shadow: 2px 2px 5px #888; padding: 5px;">
        <div class="col"><img src="<?php echo GICATALOG_URI . 'images/ajax-loader.gif'; ?>" style="display:none;" alt="loading" id="loading" /></div>
        <div class="col-right"><span style="font-size: 20px; line-height:37px"></span></div>
        <div class="clear"></div>
    </div>
    <div id="aboutgicatalog" ng-controller="About as about">
        <div id="about-message" ng-bind-html="about.statusMessage|html"></div>
        <div id="post-body" class="metabox-holder column-2">
            <div id="postbox-container-1" class="postbox-container">
                <div id="normal-sortables" class="meta-box-sortables ui-sortable">
                    <div class="postbox">
                        <div class="handlediv" title="Click to toggle"><br></div>
                        <h3 class="hndle">About GI-Catalog</h3>
                        <div class="inside">
                            <p>GI-Catalog is a convenient plugin for institutions providing online education. With this plugin they can easily organize their course materials into Groups (course), Categories & Sub-categories (chapters/sections) and further organize it into Tabs and Accordions. It is also a convenient tool for organizations providing support services to their customers with FAQs. They can organize their FAQs into Accordions which makes it easier for the customers to search through the FAQs. For religious institutions, it's also useful for them to create a Fatawa catalog and organize into Accordions with search facility, so user can search easily through entire catalog of Fatawa.</p>
                            <p>This plugin is a family product of our E-Learning suite after media library plugin <a href="http://www.glareofislam.com/softwares/gimedialibrary.html">GI-Media Library</a> which is basically used to create lecture and course library in a tabular form.</p>
                            <p>Following are the complete list of features:</p>
                            <ul>
                                <li>Organize into Groups, Categories, Sub-categories, Tabs and Accordions.</li>
                                <li>Search through entire Group or Category. Search feature will currently only search inside Accordions within Group/Category which is useful for FAQs and Fatawa database.</li>
                                <li>Possibility to easily manage styles with CSS classes and make text direction to LTR/RTL for Groups, Categories, Sub-Categories, Tabs and Accordions.</li>
                                <li>Possibility to share particular Accordion and it's contents to Facebook and Email. Useful for sharing FAQs, fatawa and specific course lecture/material.</li>
                                <li>Shortcode button on text editor in Page/Post for easily selecting the catalog to display on Page/Post with different options like Show/Hide Pagination, Show/Hide Search bar, No. of Accordions per page (useful to limit the FAQs/Fatawa per page), Hide tab header in case there is single tab in category.</li>
                                <li>Ability to use built-in WordPress Audio player with shortcode [audio src="url_to_file"] to play mp3, m4a, ogg, wav, wma audio files.</li>
                            </ul>
                            <p><b>Note:</b> PHP version of at least 5.4 is highly recommended for this plugin.</p>
                        </div>
                    </div>
                </div>
            </div>
            <div id="postbox-container-2" class="postbox-container">
                <div id="side-sortables" class="meta-box-sortables ui-sortable">
                    <div class="postbox">
                        <div class="handlediv" title="Click to toggle"><br></div>
                        <h3 class="hndle">Author and License</h3>
                        <div class="inside">
                            <p>This plugin was written and developed by <a href="http://www.glareofislam.com/softwares/gicatalog.html" target="_blank">Zishan Javaid</a>. It is licensed as Free Software under <a href="http://www.gnu.org/licenses/gpl-2.0.html" target="_blank">GNU General Public License 2 (GPL 2)</a>. If you like the plugin, giving a <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=HQ2DHNS7TQNZ8" target="_blank">donation</a> is recommended. Please rate and review the plugin in the <a href="http://wordpress.org/plugins/gi-catalog/" target="_blank">WordPress Plugin Directory</a>. Donations and good ratings encourage me to further develop the plugin and to provide countless hours of support. Any amount is appreciated! Thanks!</p>
                        </div>
                    </div>
                    <div class="postbox">
                        <div class="handlediv" title="Click to toggle"><br></div>
                        <h3 class="hndle">Donate by PayPal</h3>
                        <div class="inside">
                            <p align="center"><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=EPRAWSTXCGTP4" target="_blank">
                                    <img src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" id="paypal-submit" alt="PayPal - The safer, easier way to pay online!" style="cursor:pointer"></a></p>
                        </div>
                    </div>
                    <div class="postbox">
                        <div class="handlediv" title="Click to toggle"><br></div>
                        <h3 class="hndle">Comments/Suggestion</h3>
                        <div class="inside">
                            <div class="input-text-wrap">
                                <label class="prompt" for="gicatalog-about-name"><font color="#FF0000">*</font> Name:</label><br />
                                <input type="text" id="gicatalog-about-name" name="gicatalog-about-name" style="width:100%" autocomplete="off" ng-model="about.name">
                            </div>
                            <div class="input-text-wrap">
                                <label class="prompt" for="gicatalog-about-email"><font color="#FF0000">*</font> Email:</label><br />
                                <input type="text" id="gicatalog-about-email" name="gicatalog-about-email" style="width:100%" autocomplete="off" ng-model="about.email">
                            </div>
                            <div class="input-text-wrap">
                                <label class="prompt" for="gicatalog-about-subject"><font color="#FF0000">*</font> Subject:</label><br />
                                <input type="text" id="gicatalog-about-subject" name="gicatalog-about-subject" style="width:100%" autocomplete="off" ng-model="about.subject">
                            </div>
                            <div class="textarea-wrap">
                                <label class="prompt" for="gicatalog-about-comment"><font color="#FF0000">*</font> Message:</label><br />
                                <textarea id="gicatalog-about-comment" style="width:100%" name="gicatalog-about-comment" cols="34" rows="10" ng-model="about.message"></textarea>
                            </div>
                            <input type="submit" name="submit" value="Send" class="button-primary" ng-disabled="about.name.length==0 || about.email.length==0 || about.subject.length==0 || about.message.length==0" ng-click="about.send()">
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="clear"></div>
    </div>      <!-- END ABOUT TAB -->
</div>