'use strict';

catalog.directive('giAccordions', function(TEMPLATE_URI, $timeout, $http, URI) {
        return {
            restrict: "E",
            replace: true,
            scope: {
                tabId: '@',
                accordionId: '@'
            },
            controller: function($scope) {
                
                var tmp = ld.find($scope.$parent.$parent.$parent.categories.tab.data, function(tab) {
                    return tab.id == $scope.tabId;
                });
                $scope.collection = tmp.accordions;
                $scope.showAccordionContent = (tmp.showaccordioncontent === "true");
                $scope.myURI = URI;
                
                if (!ld.isEmpty(tmp.accordions))
                    $scope.showAccordionIcons = (tmp.accordions.length > 0);
                else
                    $scope.showAccordionIcons = false;
                
                $scope.showLinkIcon = (tmp.showlinkicon === "true");
                $scope.showEmailIcon = (tmp.showemailicon === "true");
                $scope.showShareIcon = (tmp.showshareicon === "true");
                
                $scope.showCreateDialog = function showAccordionCreateDialog() {
                    tb_show('Create Accordions', '#TB_inline?inlineId=create-accordions&width=530&height=400');
                    /*if (angular.isDefined(subcatid)) {
                        self.selected = angular.copy(self.findCat(subcatid));
                    } else {
                        self.selected = [];
                    }*/
                    $scope.$parent.$parent.$parent.categories.accordion.rows = [];
                    $timeout(function() {
                        $scope.$parent.$parent.$parent.categories.accordion.isEditMode = false;
                        $scope.$parent.$parent.$parent.categories.accordion.insertRow();
                    });
                };
                
                $scope.remove = function remove(accordionid) {
                    var tabid = parseInt(accordionid.split("-")[1]),
                    id = parseInt(accordionid.split("-")[3]);
            
                    jQuery.showStatusDialog({'message': 'Removing accordion&hellip;'});
            
                    var data = {
                        action: 'gicatalog_remove_accordion',
                        categoryid: $scope.$parent.$parent.$parent.categories.selectedCategoryId,
                        tabid: tabid,
                        accordionid: id,
                        groupid: $scope.$parent.$parent.$parent.categories.group.selected["groupid"],
                        _ajax_nonce: categoryData.nonce
                    };

                    $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
                        if (response.data.success) {
                            $timeout(function() {
                                $scope.$parent.$parent.$parent.categories.data = response.data.data;
                                $scope.$parent.$parent.$parent.categories.manageContent($scope.$parent.$parent.$parent.categories.selectedCategoryId);
                                $scope.$parent.$parent.$parent.categories.tab.cancel();
                            });
                        } else {

                        }
                        $timeout(function() {
                            jQuery('#categories-message').html(response.data.message).show();
                            jQuery.showStatusDialog({show: false});
                            jQuery.scrollTo('#categories-message', 800, {offset: -35});
                        });
                    }, function(rejectReason) {
                        //self.showAddCategoriesDialog();
                        console.log("request error");
                        console.dir(rejectReason);
                    });
                };
                
                $scope.edit = function edit(accordionid) {
                    tb_show('Edit Accordion', '#TB_inline?inlineId=create-accordions&width=530&height=400');
                    var tabid = parseInt(accordionid.split("-")[1]);
                    var id = parseInt(accordionid.split("-")[3]);
                    
                    var tmp = ld.find($scope.$parent.$parent.$parent.categories.tab.data, function(tab) {
                        return tab.id == tabid;
                    });
                    $timeout(function() {
                        $scope.$parent.$parent.$parent.categories.accordion.isEditMode = true;
                        $scope.$parent.$parent.$parent.categories.accordion.rows = [ld.find(tmp.accordions, function(accordion) {
                            return accordion.id == id;
                        })];
                    });
                };
            },
            templateUrl: TEMPLATE_URI + 'accordion.html',
            link: function(scope, element, attrs) {
                
            }
        };
    })
    .directive('accordionItemsLoaded', function($timeout, $compile, $window) {
        return function(scope, element, attrs) {
            
            if (scope.$last) {
                $timeout(function(){
                    /*jQuery( "#managecontent-accordions" + scope.$parent.tabId + " div div div").each(function(){
                        var id = jQuery(this).attr('id'),
                        panelId = jQuery(this).attr('contentid'),
                        textfield_id = id.replace(/\-/g, ""),
                        tmp = ld.find(scope.$parent.collection, function(accordion) {
                            return accordion.id == panelId;
                        });
                        jQuery(this).html($compile('<gi-text-editor ed-id="' + textfield_id + '">' + ld.stripslashes(tmp.accordioncontent) + '</gi-text-editor>')(scope));
                        
                    });*/
                    jQuery( "#" + scope.$parent.accordionId + scope.$parent.tabId ).accordion({
                        header: "> div > h3",
                        heightStyle: "content"
                    });
                    //TODO: There is a known bug in sorting the accordion. See #10556
                    /*.sortable({
                        axis: "y",
                        handle: "h3",
                        stop: function( event, ui ) {
                            // IE doesn't register the blur when sorting
                            // so trigger focusout handlers to remove .ui-state-focus
                            ui.item.children( "h3" ).triggerHandler( "focusout" );
                            // Refresh accordion to handle new order
                            jQuery( this ).accordion( "refresh" );
                            //$timeout(function(){
                                jQuery( "#" + scope.$parent.accordionId + scope.$parent.tabId ).find('.ui-accordion-content').each(function(){
                                    var id = parseInt(jQuery(this).attr('contentid')),
                                    accordionId = jQuery(this).attr('id');
                                    
                                    var textfield_id = accordionId.replace(/\-/g, ""), qtId;console.log(textfield_id);console.log(tinymce.editors);
                                    tinymce.editors[textfield_id].remove();console.log(tinymce.editors);
                                    
                                    /*$window.tinyMCEPreInit.mceInit[textfield_id] = ld.extend({}, tinyMCEPreInit.mceInit['content'], {id: textfield_id});
                                    //$window.tinyMCEPreInit.mceInit[textfield_id].plugins =  $window.tinyMCEPreInit.mceInit[textfield_id].plugins.replace(/,?wpfullscreen/, '');
                                    if (ld.isUndefined(tinyMCEPreInit.qtInit[textfield_id])) {
                                        $window.tinyMCEPreInit.qtInit[textfield_id] = ld.extend({}, tinyMCEPreInit.qtInit['content'], {id: textfield_id});
                                    }

                                    quicktags($window.tinyMCEPreInit.qtInit[textfield_id]);
                                    QTags._buttonsInit();
                                    $window.switchEditors.go(textfield_id, 'tmce');

                                    tinymce.execCommand('mceAddEditor', true, textfield_id);

                                    if (typeof jQuery !== 'undefined') {
                                        //added remove listener code
                                        jQuery('.wp-editor-wrap').off('click.wp-editor').on('click.wp-editor', function() {
                                            if (this.id) {
                                                window.wpActiveEditor = this.id.slice(3, -5);
                                            }
                                        });
                                    } else {
                                        for (qtId in tinyMCEPreInit.qtInit) {
                                            //added remove listener code
                                            document.getElementById('wp-' + qtId + '-wrap').onclick = null;
                                            document.getElementById('wp-' + qtId + '-wrap').onclick = function() {
                                                window.wpActiveEditor = this.id.slice(3, -5);
                                            };
                                        }
                                    }

                                    //codes taken from WP 3.9.1 wp-includes\js\media-editor.js line 1036 to enable drag drop upload on editor
                                    jQuery(wp.media.editor).unbind('open');
                                    ld.bindAll( wp.media.editor, 'open' );
                                    jQuery( wp.media.editor.init );*/
                    /*            });
                            //});
                        }
                    });*/
                    jQuery( "#" + scope.$parent.accordionId + scope.$parent.tabId ).accordion("refresh");
                });
                
            }
        };
    });