'use strict';

catalog.directive('giTabs', function($compile, $timeout, $http, URI) {
        return {
            restrict: "E",
            replace: true,
            scope: {
                tabId: '@',
                collection: '='
            },
            controller: function($scope) {
                $scope.remove1 = function remove1(tabid) {
                    jQuery( "#" + tabid ).remove();

                    ld.remove($scope.$parent.categories.tab.data, function(tab) {
                        return tab.id == parseInt(tabid.split("-")[1]);
                    });
                    $scope.$parent.categories.tab.tabs.tabs( "refresh" );
                };
                
                $scope.remove = function remove(tabid) {
                    var id = parseInt(tabid.split("-")[1]);
            
                    jQuery.showStatusDialog({'message': 'Removing tab&hellip;'});
            
                    var data = {
                        action: 'gicatalog_remove_tab',
                        categoryid: $scope.$parent.categories.selectedCategoryId,
                        tabid: id,
                        groupid: $scope.$parent.categories.group.selected["groupid"],
                        _ajax_nonce: categoryData.nonce
                    };

                    $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
                        if (response.data.success) {
                            $timeout(function() {
                                $scope.$parent.categories.data = response.data.data;
                                $scope.$parent.categories.manageContent($scope.$parent.categories.selectedCategoryId);
                                $scope.$parent.categories.tab.cancel();
                            });
                        } else {

                        }
                        $timeout(function() {
                            jQuery('#categories-message').html(response.data.message).show();
                            jQuery.showStatusDialog({show: false});
                            jQuery.scrollTo('#categories-message', 800, {offset: -35});
                        });
                    }, function(rejectReason) {
                        //self.showAddCategoriesDialog();
                        console.log("request error");
                        console.dir(rejectReason);
                    });
                };
                
                $scope.edit = function edit(tabid) {
                    tb_show('Edit Tab', '#TB_inline?inlineId=create-tabs&width=530&height=400');
                    
                    $timeout(function() {
                        $scope.$parent.categories.tab.isEditMode = true;
                        $scope.$parent.categories.tab.rows = [ld.find($scope.$parent.categories.tab.data, function(tab) {
                            return tab.id == parseInt(tabid.split("-")[1]);
                        })];
                    });
                };
            },
            template: '<div id="{{tabId}}"><ul><li ng-repeat="tab in collection track by $index" class="repeated-item" tab-items-loaded>' +
                            '<a href="{{\'#tabs-\' + tab.id}}" ng-class="((tab.tabdirection === \'rtl\')?\'text-right\':\'text-left\') + \' \' + tab.tabcss" ng-bind="tab.tabname|text"></a> <span class="ui-icon ui-icon-pencil" role="presentation" title="edit tab" ng-click="edit(\'tabs-\' + tab.id)">Edit Tab</span><span class="ui-icon ui-icon-close" role="presentation" title="remove tab" ng-click="remove(\'tabs-\' + tab.id)">Remove Tab</span>' +
                        '</li></ul>\n\
                        <div ng-repeat="tab in collection track by $index" id="{{\'tabs-\' + tab.id}}"><div id="{{\'tabs-\' + tab.id + \'-content\'}}"><gi-text-editor ed-id="{{\'tabs\' + tab.id + \'content\'}}"><div ng-bind-html="tab.tabcontent|html"></div></gi-text-editor></div><gi-accordions accordion-id="managecontent-accordions" tab-id="{{tab.id}}"></gi-accordions></div>\n\
                    </div>',
            link: function(scope, element, attrs) {
                /*var jTab = scope.$parent.categories.tab.tabs;
                scope.$watch('collection', function(col) {
                    if (col.length > 0) {
                        angular.forEach(col, function(tab){
                            var id = "tabs-" + tab.id,
                            textfield_id = id.replace(/\-/g, "") + 'content',
                            content = "<div id='" + id + "'><div id='" + id + "-content'><gi-text-editor ed-id=\"" + textfield_id + "\">" + ld.stripslashes(tab.tabcontent) + "</gi-text-editor></div><p><label><input type=\"checkbox\" ng-model=\"categories.showAccordionContent" + tab.id + "\">Show accordion content</label></p><div id=\"managecontent-accordions" + tab.id + "\" ng-show=\"categories.showAccordionContent" + tab.id + "\"><gi-accordions tab-id=\"" + tab.id + "\"></gi-accordions><div class=\"insert-row\"><p><span ng-click=\"categories.accordion.showCreateDialog()\"><img src=\"http://wp1.gi.com/wp-content/plugins/gi-catalog/images/add-icon.png\" alt=\"add accordion\" title=\"add accordion\">&nbsp;add accordion</span></p></div></div></div>";
                            //remove any previous instance of editor with similar id
                            if (angular.isObject(tinymce.editors[textfield_id]))
                                tinymce.editors[textfield_id].remove();

                            content = $compile(content)(scope.$parent);
                            jTab.append(content);
                            jTab.tabs( "refresh" );
                            
                        });
                        jTab.tabs('option', 'active', 0);
                    }
                    jTab.find( ".ui-tabs-nav" ).append($compile('<li class="insert-tab tab-disabled"><span ng-click="categories.tab.showCreateDialog()"><img src="http://wp1.gi.com/wp-content/plugins/gi-catalog/images/add-icon.png" alt="add tab" title="add tab"></span></li>')(scope.$parent));
                    jTab.tabs("refresh");
                });*/
            }
        };
    })
    .directive('tabItemsLoaded', function($timeout, $compile, URI) {
        return function(scope, element, attrs) {
            var jTab = scope.$parent.$parent.categories.tab.tabs;
            //jTab.tabs( "refresh" );
            
                /*var id = "tabs-" + scope.tab.id,
                textfield_id = id.replace(/\-/g, "") + 'content',
                content = "<div id='" + id + "'><div id='" + id + "-content'><gi-text-editor ed-id=\"" + textfield_id + "\">" + ld.stripslashes(scope.tab.tabcontent) + "</gi-text-editor></div><p><label><input type=\"checkbox\" ng-model=\"categories.showAccordionContent" + scope.tab.id + "\">Show accordion content</label></p><div id=\"managecontent-accordions" + scope.tab.id + "\" ng-show=\"categories.showAccordionContent" + scope.tab.id + "\"><gi-accordions tab-id=\"" + scope.tab.id + "\"></gi-accordions><div class=\"insert-row\"><p><span ng-click=\"categories.accordion.showCreateDialog()\"><img src=\"http://wp1.gi.com/wp-content/plugins/gi-catalog/images/add-icon.png\" alt=\"add accordion\" title=\"add accordion\">&nbsp;add accordion</span></p></div></div></div>";
                //remove any previous instance of editor with similar id
                if (angular.isObject(tinymce.editors[textfield_id]))
                    tinymce.editors[textfield_id].remove();

                content = $compile(content)(scope.$parent.$parent);
                jQuery( "#managecontent-tabs" ).append(content);
                //jTab.tabs( "refresh" );*/
            
            if (scope.$last) {
                $timeout(function(){
                    if (jQuery("#" + scope.$parent.tabId + ' ul').find('li.insert-tab').length==0) {
                        jQuery( "#" + scope.$parent.tabId + ' ul' ).append($compile('<li class="insert-tab tab-disabled"><span ng-click="categories.tab.showCreateDialog()"><img src="' + URI + 'images/add-icon.png" alt="add tab" title="add tab"></span></li>')(scope.$parent.$parent));
                    }
                    
                    scope.$parent.$parent.categories.tab.tabs = jQuery( "#managecontent-tabs" ).tabs({
                        collapsible: true
                    }).sortable({
                        axis: "x",
                        items: "li:not(.tab-disabled)",
                        stop: function(event, ui) {
                            jQuery(this).tabs( "refresh" );
                        }
                    });
                    /*scope.$parent.$parent.categories.tab.tabs.undelegate("span.ui-icon-close", "click");
                    scope.$parent.$parent.categories.tab.tabs.delegate( "span.ui-icon-close", "click", function() {
                        var panelId = jQuery( this ).closest( "li" ).attr( "aria-controls" );

                        //jQuery( "#" + panelId ).remove();
                        
                        var tmp = ld.find(scope.$parent.$parent.categories.tab.data, function(tab) {
                            return tab.id == parseInt(panelId.split("-")[1]);
                        }),
                        id = tmp.id;

                        ld.remove(scope.$parent.$parent.categories.tab.data, function(tab) {
                            return tab.id == id;
                        });
                        scope.$parent.$parent.$apply();
                        //scope.$parent.$parent.categories.tab.tabs.tabs( "refresh" );
                    });*/
                    scope.$parent.$parent.categories.tab.tabs.tabs("refresh");
                    scope.$parent.$parent.categories.tab.tabs.tabs('option', 'active', 0);
                });

            }
        };
    });