'use strict';

catalog.directive('giTextEditor', function($window, $timeout, $sce){
        return {
            restrict: "E",
            replace: true,
            transclude: true,
            scope: {
                edId: '@',
                //edContent: '='
            },
            template: '<div bindonce bo-attr bo-attr-id="\'wp-\' + edId + \'-wrap\'" class="wp-core-ui wp-editor-wrap tmce-active">\n\
                            <div bo-attr bo-attr-id="\'wp-\' + edId + \'-editor-tools\'" class="wp-editor-tools hide-if-no-js">\n\
                                <div bo-attr bo-attr-id="\'wp-\' + edId + \'-media-buttons\'" class="wp-media-buttons">\n\
                                    <a bo-attr href="#" id="insert-media-button" class="button insert-media add_media" bo-attr-data-editor="edId" title="Add Media"><span class="wp-media-buttons-icon"></span> Add Media</a>\n\
                                </div>\n\
                                <div class="wp-editor-tabs">\n\
                                    <a bo-attr bo-attr-id="edId + \'-html\'" class="wp-switch-editor switch-html" onclick="switchEditors.switchto(this);">Text</a>\n\
                                    <a bo-attr bo-attr-id="edId + \'-tmce\'" class="wp-switch-editor switch-tmce" onclick="switchEditors.switchto(this);">Visual</a>\n\
                                </div>\n\
                            </div>\n\
                            <div bo-attr bo-attr-id="\'wp-\' + edId + \'-editor-container\'" class="wp-editor-container">\n\
                                <textarea bo-attr class="wp-editor-area" style="height: 100px" autocomplete="off" cols="40" bo-attr-name="edId" bo-attr-id="edId" ng-transclude />\n\
                            </div>\n\
                        </div>',
            link: function(scope, elm, attrs, ctrl, trnscl) {
                //TODO: In angular 1.3 this issue will be fixed and no need to create override function for transclusion (See #5489)
                trnscl(function(content){
                    $timeout(function(){
                        var text = '';
                        jQuery(content).each(function(){
                            if (angular.isDefined(jQuery(this).html()))
                                text += "<p>" + jQuery(this).html() + "</p>";
                        });
                        jQuery(elm).find("textarea").text(text);
                    });
                });
                /*scope.$watch(function(){
                    return content;
                }, function(content) {*/
                $timeout(function(){
                    if (angular.isObject(tinymce.editors[scope.edId]))
                        tinymce.editors[scope.edId].remove();

                    var textfield_id = scope.edId, qtId;
                    
                    $window.tinyMCEPreInit.mceInit[textfield_id] = ld.extend({}, tinyMCEPreInit.mceInit['content'], {id: textfield_id});
                    //$window.tinyMCEPreInit.mceInit[textfield_id].plugins =  $window.tinyMCEPreInit.mceInit[textfield_id].plugins.replace(/,?wpfullscreen/, '');
                    if (typeof quicktags !== 'undefined') {
                        if (ld.isUndefined(tinyMCEPreInit.qtInit[textfield_id])) {
                            $window.tinyMCEPreInit.qtInit[textfield_id] = ld.extend({}, tinyMCEPreInit.qtInit['content'], {id: textfield_id});
                        }

                        quicktags($window.tinyMCEPreInit.qtInit[textfield_id]);
                        QTags._buttonsInit();
                    }
                    $window.switchEditors.go(textfield_id, 'tmce');

                    tinymce.execCommand('mceAddEditor', true, textfield_id);

                    if (typeof jQuery !== 'undefined') {
                        //added remove listener code
                        jQuery('.wp-editor-wrap').off('click.wp-editor').on('click.wp-editor', function() {
                            if (this.id) {
                                window.wpActiveEditor = this.id.slice(3, -5);
                            }
                        });
                    } else {
                        for (qtId in tinyMCEPreInit.qtInit) {
                            //added remove listener code
                            document.getElementById('wp-' + qtId + '-wrap').onclick = null;
                            document.getElementById('wp-' + qtId + '-wrap').onclick = function() {
                                window.wpActiveEditor = this.id.slice(3, -5);
                            };
                        }
                    }

                    //codes taken from WP 3.9.1 wp-includes\js\media-editor.js line 1036 to enable drag drop upload on editor
                    jQuery(wp.media.editor).unbind('open');
                    ld.bindAll( wp.media.editor, 'open' );
                    jQuery( wp.media.editor.init );

                    //if (angular.isObject(tinymce.editors[scope.edId]))
                        //tinymce.get(scope.edId).setContent(content);
                //});
                });
            }
        };
    });