'use strict';

catalog.controller('Categories', function($scope, $window, $rootScope, $timeout, $http, $compile, URI) {
    this.group = {};
    this.group.data = categoryData.groups;
    this.group.selected = (this.group.data) ? this.group.data[0] : [];

    this.rows = [];//[{id: 1, name: '', css: '', direction: 'ltr', groupid: this.group.selected["groupid"]}];
    this.data = categoryData.categories;
    this.selected = []; //selected category
    this.selectedCategoryId = 0;
    this.isEditMode = false;
    this.isInsertMode = false;
    this.isManageContent = false;
    this.showTabbedContent = "false";

    this.tab = {};
    //this.tab.tabs = 
    this.tab.isEditMode = false;
    this.tab.rows = [];
    this.tab.data = [];
    this.tab.selected = [];
    
    this.accordion = {};
    this.accordion.isEditMode = false;
    this.accordion.rows = [];
    this.accordion.selected = [];
    
    var self = this;
    
    $scope.$on('group.updated', function(e, data) {
        self.group.data = data.groups;
        self.group.selected = (self.group.data) ? self.group.data[0] : [];
        /*if (angular.isDefined(data.categories)) {
            //self.data = [];
            self.data = data.categories;
        }*/
        self.group.change();
        self.cancel();
    });

    this.group.change = function change() {
        jQuery('#categories-message').html("").hide();

        jQuery.showStatusDialog({'message': 'Retrieving categories&hellip;'});

        var data = {
            action: 'gicatalog_get_group_categories',
            groupid: self.group.selected["groupid"],
            _ajax_nonce: categoryData.nonce
        };

        $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
            if (response.data.success) {
                self.cancel();
            } else {

            }
            self.data = [];
            $timeout(function() {
                self.data = response.data.data;
            });
            //$rootScope.$broadcast('group.updated', response.data.data);
            jQuery('#categories-message').html(response.data.message).show();
            jQuery.showStatusDialog({show: false});
            jQuery.scrollTo('#categories-message', 800, {offset: -35});
        }, function(rejectReason) {
            console.log("request error");
            console.dir(rejectReason);
        });
        self.cancel();
    };

    this.insertRow = function insertRow() {
        var newid = (this.rows.length > 0) ? this.rows[this.rows.length - 1].id + 1 : 1;
        if (self.selected.length > 0) {
            this.rows.push({id: newid, categoryname: '', categorycss: '', categorydirection: 'ltr', categorysortorder: newid * 10, categorycontent: '', groupid: this.group.selected["groupid"], subcategoryid: self.selected[0].categoryid});
        } else {
            this.rows.push({id: newid, categoryname: '', categorycss: '', categorydirection: 'ltr', categorysortorder: newid * 10, categorycontent: '', groupid: this.group.selected["groupid"]});
        }
    };
    this.removeRow = function removeRow(id) {
        ld.remove(this.rows, function(row) {
            return row.id == id;
        });
        /*var i = 1;
         var tmpRows = angular.copy(this.rows);
         angular.forEach(tmpRows, function(row) {
         row.id = i;
         i++;
         });
         var self = this;
         $timeout(function(){
         self.rows = angular.copy(tmpRows);
         tmpRows = null;
         });*/
    };
    this.update = function update() {
        jQuery('#categories-message').html("").hide();

        var tmpRows = angular.copy(this.rows);
        ld.remove(tmpRows, function(row) {
            return (ld.isEmpty(ld.trim(row.categoryname)));
        });
        if (tmpRows.length == 0) {
            return false;
        }
        //closes ThickBox... this is a global function inside TB file
        //tb_remove();

        $timeout(function() {
            if (self.isEditMode) {
                jQuery.showStatusDialog({'message': 'Updating category&hellip;'});
            } else {
                jQuery.showStatusDialog({'message': 'Adding category(ies)&hellip;'});
            }

            var data = {
                action: (self.isEditMode) ? 'gicatalog_update_category' : 'gicatalog_add_category',
                rows: tmpRows,
                groupid: self.group.selected["groupid"],
                _ajax_nonce: categoryData.nonce
            };

            $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
                if (response.data.success) {
                    self.cancel();
                } else {

                }
                self.data = [];
                $timeout(function() {
                    self.data = response.data.data;
                });
                //$rootScope.$broadcast('group.updated', response.data.data);
                jQuery('#categories-message').html(response.data.message).show();
                jQuery.showStatusDialog({show: false});
                jQuery.scrollTo('#categories-message', 800, {offset: -35});
            }, function(rejectReason) {
                //self.showAddCategoriesDialog();
                console.log("request error");
                console.dir(rejectReason);
            });
        });
    };

    this.catDelete = function catDelete(categoryid) {
        jQuery('#categories-message').html("").hide();

        if (!categoryid) {
            return false;
        }
        jQuery.showStatusDialog({message: 'Deleting category&hellip;'});

        var data = {
            action: 'gicatalog_delete_category',
            ids: categoryid,
            groupid: this.group.selected["groupid"],
            _ajax_nonce: categoryData.nonce
        };

        $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
            if (response.data.success) {
                self.cancel();
            } else {

            }
            self.data = [];
            $timeout(function() {
                self.data = response.data.data;
            });
            //$rootScope.$broadcast('group.updated', response.data.data);
            jQuery('#categories-message').html(response.data.message).show();
            jQuery.showStatusDialog({show: false});
            jQuery.scrollTo('#categories-message', 800, {offset: -35});
        }, function(rejectReason) {
            console.log("request error");
            console.dir(rejectReason);
        });

    };

    this.edit = function edit(categoryid) {
        self.rows = [];
        $timeout(function() {
            self.isEditMode = true;
            self.isInsertMode = self.isManageContent = false;
            self.rows = angular.copy(self.findCat(categoryid));
        });
    };

    this.cancel = function cancel() {
        self.isEditMode = self.isInsertMode = self.isManageContent = false;
        self.showTabbedContent = "false";
        self.selectedCategoryId = 0;
        ld.remove(self.rows);
    };

    this.showAddCategoriesDialog = function showAddCategoriesDialog(subcatid) {
        //tb_show('Create Categories', '#TB_inline?inlineId=create-categories');
        if (angular.isDefined(subcatid)) {
            self.selected = angular.copy(self.findCat(subcatid));
        } else {
            self.selected = [];
        }
        self.rows = [];
        $timeout(function() {
            self.isEditMode = self.isManageContent = false;
            self.isInsertMode = true;
            self.insertRow();
        });
    };

    this.findCat = function findCat(catid) {
        var tmpCol = [];

        function findme(data, id) {
            /*angular.forEach(data, function(cat, key){console.log("here1");
             if (cat.categoryid == id) {console.log("here2");
             this.push(cat);
             return false;
             } else if (angular.isDefined(cat.subcategory)) {
             var subcat = findme(cat.subcategory, catid);console.log("here3");
             if (subcat) {console.log("here4");
             this.push(subcat);
             return false;
             }
             }
             }, tmpCol);
             return tmpCol;*/
            ld(data).forEach(function(cat) {
                //we need single record only
                if (!ld.isEmpty(tmpCol)) {
                    return false;
                }
                if (cat.categoryid == id) {
                    this.push(cat);
                    return false;
                } else if (angular.isDefined(cat.subcategory)) {
                    return findme(cat.subcategory, catid);
                }
            }, tmpCol);
            return tmpCol;
        }
        var found = findme(self.data, catid);
        return found;
    };

    this.manageContent = function manageContent(catid) {
        self.rows = [];
        
        self.selectedCategoryId = catid;
        var tmpcat = angular.copy(self.findCat(catid))[0];
        ld.remove(self.tab.data);
        
        $timeout(function() {
            //remove all previous instances of tabs and editors before adding new tab data
            //first remove all tabs
            /*if (self.tab.tabs) {
                self.tab.tabs.find( ".ui-tabs-nav li" ).each(function(){
                    var panelId = jQuery( this ).remove().attr( "aria-controls" );
                    jQuery( "#" + panelId ).remove();
                    self.tab.tabs.tabs( "refresh" );
                });
            }*/
            //remove all editors
            for (var edId in tinymce.editors)
                tinymce.editors[edId].remove();

            self.tab.data = angular.isObject(tmpcat.categorycontent)?tmpcat.categorycontent.tabs:[];
            self.showTabbedContent = angular.isObject(tmpcat.categorycontent)?(tmpcat.categorycontent.showtabbedcontent==="true"):false;
            self.selected = {content: angular.isObject(tmpcat.categorycontent)?tmpcat.categorycontent.content:''};
            
            if (self.tab.data.length == 0) {
                if (jQuery("#managecontent-tabs ul").find('li.insert-tab').length==0) {
                    jQuery( "#managecontent-tabs ul" ).append($compile('<li class="insert-tab tab-disabled"><span ng-click="categories.tab.showCreateDialog()"><img src="' + URI + 'images/add-icon.png" alt="add tab" title="add tab"></span></li>')($scope));
                    self.tab.tabs = jQuery( "#managecontent-tabs" ).tabs({
                        collapsible: true
                    }).sortable({
                        axis: "x",
                        items: "li:not(.tab-disabled)",
                        stop: function(event, ui) {
                            jQuery(this).tabs( "refresh" );
                        }
                    });
                }
            }
            
            self.isEditMode = self.isInsertMode = false;
            
            var txted = $compile('<gi-text-editor ed-id="maincontent">' + ld.stripslashes(self.selected.content) + '</gi-text-editor>')($scope);
            jQuery('#main-content').html(txted);
            
            self.isManageContent = true;
        });
    };

    this.tinymce_Init = function tinymce_Init() {
        //codes taken from WP 3.9.1 wp-includes/class-wp-editor.php function editor_js() line 1124 
        /*var init, edId, qtId, firstInit, wrapper;

        if (typeof tinymce !== 'undefined') {
            for (edId in tinyMCEPreInit.mceInit) {

                if (firstInit) {
                    init = tinyMCEPreInit.mceInit[edId] = tinymce.extend({}, firstInit, tinyMCEPreInit.mceInit[edId]);
                } else {
                    init = firstInit = tinyMCEPreInit.mceInit[edId];
                }

                wrapper = tinymce.DOM.select('#wp-' + edId + '-wrap')[0];

                if ((tinymce.DOM.hasClass(wrapper, 'tmce-active') || !tinyMCEPreInit.qtInit.hasOwnProperty(edId)) &&
                        !init.wp_skip_init) {

                    try {
                        tinymce.init(init);

                        if (!window.wpActiveEditor) {
                            window.wpActiveEditor = edId;
                        }
                    } catch (e) {
                    }
                }
            }
        }

        if (typeof quicktags !== 'undefined') {
            for (qtId in tinyMCEPreInit.qtInit) {
                try {
                    quicktags(tinyMCEPreInit.qtInit[qtId]);

                    if (!window.wpActiveEditor) {
                        window.wpActiveEditor = qtId;
                    }
                } catch (e) {
                }
                
            }
        }*/

        if (typeof jQuery !== 'undefined') {
            //added remove listener code
            jQuery('.wp-editor-wrap').off('click.wp-editor').on('click.wp-editor', function() {
                if (this.id) {
                    window.wpActiveEditor = this.id.slice(3, -5);
                }
            });
        } else {
            for (qtId in tinyMCEPreInit.qtInit) {
                //added remove listener code
                document.getElementById('wp-' + qtId + '-wrap').onclick = null;
                document.getElementById('wp-' + qtId + '-wrap').onclick = function() {
                    window.wpActiveEditor = this.id.slice(3, -5);
                };
            }
        }
     
        //codes taken from WP 3.9.1 wp-includes\js\media-editor.js line 1036 to enable drag drop upload on editor
        jQuery(wp.media.editor).unbind('open');
        ld.bindAll( wp.media.editor, 'open' );
	jQuery( wp.media.editor.init );
    };

    //Tab codes
    this.tab.cancel = function tabCancel() {
        self.tab.isEditMode = false;
        ld.remove(self.tab.rows);
        ld.remove(self.tab.selected);
    };
    this.tab.showCreateDialog = function showCreateDialog() {
        tb_show('Create Tabs', '#TB_inline?inlineId=create-tabs&width=530&height=400');
        /*if (angular.isDefined(subcatid)) {
            self.selected = angular.copy(self.findCat(subcatid));
        } else {
            self.selected = [];
        }*/
        self.tab.rows = [];
        $timeout(function() {
            self.tab.isEditMode = false;
            self.tab.insertRow();
        });
    };
    this.tab.insertRow = function tab_insertRow() {
        var newid = (self.tab.rows.length > 0) ? self.tab.rows[self.tab.rows.length - 1].id + 1 : 1;
        if (self.tab.selected.length > 0) {
            self.tab.rows.push({id: newid, tabname: '', tabcss: '', tabdirection: 'ltr', tabcontent: ''});//, groupid: this.group.selected["groupid"], subcategoryid: self.selected[0].categoryid});
        } else {
            self.tab.rows.push({id: newid, tabname: '', tabcss: '', tabdirection: 'ltr', tabcontent: ''});//, groupid: this.group.selected["groupid"]});
        }
    };
    this.tab.removeRow = function tab_removeRow(id) {
        ld.remove(self.tab.rows, function(row) {
            return row.id == id;
        });
        /*var i = 1;
         var tmpRows = angular.copy(this.rows);
         angular.forEach(tmpRows, function(row) {
         row.id = i;
         i++;
         });
         var self = this;
         $timeout(function(){
         self.rows = angular.copy(tmpRows);
         tmpRows = null;
         });*/
    };
    this.tab.update = function tab_update() {
        jQuery('#categories-message').html("").hide();
        
        var tmpRows = angular.copy(self.tab.rows);
        ld.remove(tmpRows, function(row){
            return (ld.isEmpty(ld.trim(row.tabname)));
        });
        if (tmpRows.length == 0 || self.selectedCategoryId == 0) {
            return false;
        }
        
        //closes ThickBox... this is a global function inside TB file
        tb_remove();
        
        $timeout(function() {
            if (self.tab.isEditMode) {
                jQuery.showStatusDialog({'message': 'Updating tab&hellip;'});
            } else {
                jQuery.showStatusDialog({'message': 'Adding tab(s)&hellip;'});
            }

            var data = {
                action: (self.tab.isEditMode) ? 'gicatalog_update_tab' : 'gicatalog_add_tab',
                rows: tmpRows,
                categoryid: self.selectedCategoryId,
                groupid: self.group.selected["groupid"],
                _ajax_nonce: categoryData.nonce
            };

            $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
                self.data = [];
                if (response.data.success) {
                    if (self.tab.isEditMode) {//we need to refresh the data completely
                        ld.remove(self.tab.data);
                    }
                    $timeout(function() {
                        self.data = response.data.data;
                        /*var tmpcat = angular.copy(self.findCat(self.selectedCategoryId))[0];
                        self.tab.data = angular.isObject(tmpcat.categorycontent)?tmpcat.categorycontent.tabs:[];*/
                        //self.create_tabs(self.tab.data);
                        self.manageContent(self.selectedCategoryId);
                        self.tab.cancel();
                    });

                    
                } else {

                }
                $timeout(function() {
                    jQuery('#categories-message').html(response.data.message).show();
                    jQuery.showStatusDialog({show: false});
                    jQuery.scrollTo('#categories-message', 800, {offset: -35});
                });
            }, function(rejectReason) {
                //self.showAddCategoriesDialog();
                console.log("request error");
                console.dir(rejectReason);
            });
        });
    };
    
    //Accordion codes
    this.accordion.cancel = function accordionCancel() {
        self.accordion.isEditMode = false;
        ld.remove(self.accordion.rows);
        ld.remove(self.accordion.selected);
    };
    this.accordion.insertRow = function accordion_insertRow() {
        var newid = (self.accordion.rows.length > 0) ? self.accordion.rows[self.accordion.rows.length - 1].id + 1 : 1;
        if (self.accordion.selected.length > 0) {
            self.accordion.rows.push({id: newid, accordionname: '', accordioncss: '', accordiondirection: 'ltr', accordioncontent: ''});//, groupid: this.group.selected["groupid"], subcategoryid: self.selected[0].categoryid});
        } else {
            self.accordion.rows.push({id: newid, accordionname: '', accordioncss: '', accordiondirection: 'ltr', accordioncontent: ''});//, groupid: this.group.selected["groupid"]});
        }
    };
    this.accordion.removeRow = function accordion_removeRow(id) {
        ld.remove(self.accordion.rows, function(row) {
            return row.id == id;
        });
    };
    this.accordion.update = function accordion_update() {
        jQuery('#categories-message').html("").hide();
        
        var panelId = jQuery(self.tab.tabs.find(".ui-tabs-nav li")[self.tab.tabs.tabs( "option", "active" )]).attr( "aria-controls" );
        var tabId = parseInt(panelId.split("-")[1]);
        var tmpRows = angular.copy(self.accordion.rows);
        ld.remove(tmpRows, function(row){
            return (ld.isEmpty(ld.trim(row.accordionname)));
        });
        if (tmpRows.length == 0 || self.selectedCategoryId == 0) {
            return false;
        }
        
        //closes ThickBox... this is a global function inside TB file
        tb_remove();
        
        $timeout(function() {
            if (self.accordion.isEditMode) {
                jQuery.showStatusDialog({'message': 'Updating accordion&hellip;'});
            } else {
                jQuery.showStatusDialog({'message': 'Adding accordion(s)&hellip;'});
            }
            
            var data = {
                action: (self.accordion.isEditMode) ? 'gicatalog_update_accordion' : 'gicatalog_add_accordion',
                rows: tmpRows,
                categoryid: self.selectedCategoryId,
                groupid: self.group.selected["groupid"],
                tabid: tabId,
                _ajax_nonce: categoryData.nonce
            };

            $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
                self.data = [];
                if (response.data.success) {
                    $timeout(function() {
                        self.data = response.data.data;
                        self.manageContent(self.selectedCategoryId);
                        self.accordion.cancel();
                    });

                    
                } else {

                }
                $timeout(function() {
                    jQuery('#categories-message').html(response.data.message).show();
                    jQuery.showStatusDialog({show: false});
                    jQuery.scrollTo('#categories-message', 800, {offset: -35});
                });
            }, function(rejectReason) {
                //self.showAddCategoriesDialog();
                console.log("request error");
                console.dir(rejectReason);
            });
        });
    };
    this.save = function save_contents() {
        tinymce.get("maincontent").save();
        
        var tabs = [],
        categorycontent = tinymce.get("maincontent").getContent();//jQuery("#maincontent").val();
            
        self.tab.tabs.find(".ui-tabs-nav li").each(function(){
            if (jQuery(this).hasClass('insert-tab')) {
                return false;
            }
            
            var panelId = jQuery( this ).attr( "aria-controls" ),
            textfield_id = panelId.replace(/\-/g, "") + 'content';
            
            var tmp = ld.find(self.tab.data, function(tab) {
                return tab.id == parseInt(panelId.split("-")[1]);
            });
            
            tabs.push(angular.copy(tmp));
            
            tabs[tabs.length-1]["tabname"] = ld.stripslashes(tabs[tabs.length-1]["tabname"]);
            tabs[tabs.length-1]["tabcss"] = ld.stripslashes(tabs[tabs.length-1]["tabcss"]);
            tinymce.get(textfield_id).save();
            tabs[tabs.length-1]["tabcontent"] = tinymce.get(textfield_id).getContent();//jQuery("#" + textfield_id).val();
            
            //accordion section
            var showaccordioncontent = (jQuery('#' + panelId + '-showaccordioncontent:checked').length>0),
                    showlinkicon = (jQuery('#' + panelId + '-showlinkicon:checked').length>0),
                    showemailicon = (jQuery('#' + panelId + '-showemailicon:checked').length>0),
                    showshareicon = (jQuery('#' + panelId + '-showshareicon:checked').length>0),
                    accordions = [];
    
            jQuery('#managecontent-accordions' + panelId.split("-")[1]).find('.ui-accordion-content').each(function(){
                var id = parseInt(jQuery(this).attr('contentid')),
                accordionId = jQuery(this).attr('id');
                
                var tmpaccord = ld.find(tmp.accordions, function(accordion){
                    return accordion.id == id;
                });
                accordions.push(angular.copy(tmpaccord));
                
                accordions[accordions.length-1]['accordionname'] = ld.stripslashes(accordions[accordions.length-1]["accordionname"]);
                accordions[accordions.length-1]['accordioncss'] = ld.stripslashes(accordions[accordions.length-1]["accordioncss"]);
                tinymce.get(accordionId.replace(/\-/g, "")).save();
                accordions[accordions.length-1]["accordioncontent"] = tinymce.get(accordionId.replace(/\-/g, "")).getContent();//jQuery("#" + accordionId.replace(/\-/g, "")).val();
            });
            tabs[tabs.length-1]['showaccordioncontent'] = showaccordioncontent;
            tabs[tabs.length-1]['showlinkicon'] = showlinkicon;
            tabs[tabs.length-1]['showemailicon'] = showemailicon;
            tabs[tabs.length-1]['showshareicon'] = showshareicon;
            tabs[tabs.length-1]['accordions'] = angular.copy(accordions);
        });
        
        var data = {'showtabbedcontent': self.showTabbedContent ,'content': categorycontent, 'tabs': tabs};
        jQuery.showStatusDialog({'message': 'Saving category contents&hellip;'});
            
        var data = {
            action: 'gicatalog_save_category',
            data: data,
            categoryid: self.selectedCategoryId,
            groupid: self.group.selected["groupid"],
            _ajax_nonce: categoryData.nonce
        };

        $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
            self.data = [];
            if (response.data.success) {
                $timeout(function() {
                    self.data = response.data.data;
                    /*var tmpcat = angular.copy(self.findCat(self.selectedCategoryId))[0];
                    self.tab.data = angular.isObject(tmpcat.categorycontent)?tmpcat.categorycontent.tabs:[];
                    self.create_tabs(self.tab.data);*/
                    self.manageContent(self.selectedCategoryId);
                    self.tab.cancel();
                });
            } else {

            }
            $timeout(function() {
                jQuery('#categories-message').html(response.data.message).show();
                jQuery.showStatusDialog({show: false});
                jQuery.scrollTo('#categories-message', 800, {offset: -35});
            });
        }, function(rejectReason) {
            //self.showAddCategoriesDialog();
            console.log("request error");
            console.dir(rejectReason);
        });
    };
    
    this.create_textEditor = function create_textEditor(textfield_id) {
                    
        $window.tinyMCEPreInit.mceInit[textfield_id] = ld.extend({}, tinyMCEPreInit.mceInit['content'], {id: textfield_id});
        //$window.tinyMCEPreInit.mceInit[textfield_id].plugins =  $window.tinyMCEPreInit.mceInit[textfield_id].plugins.replace(/,?wpfullscreen/, '');
        if (ld.isUndefined(tinyMCEPreInit.qtInit[textfield_id])) {
            $window.tinyMCEPreInit.qtInit[textfield_id] = ld.extend({}, tinyMCEPreInit.qtInit['content'], {id: textfield_id});
        }

        quicktags($window.tinyMCEPreInit.qtInit[textfield_id]);
        QTags._buttonsInit();
        $window.switchEditors.go(textfield_id, 'tmce');

        tinymce.execCommand('mceAddEditor', true, textfield_id);
        
        self.tinymce_Init();
    };
    
    this.create_tabs = function create_tabs(tabs) {
        //first remove all tabs
        self.tab.tabs.find( ".ui-tabs-nav li" ).each(function(){
            var panelId = jQuery( this ).remove().attr( "aria-controls" );
            jQuery( "#" + panelId ).remove();
            self.tab.tabs.tabs( "refresh" );
        });
        
        angular.forEach(tabs, function(tab, key) {
            var label = ld.stripslashes(tab.tabname),
            id = "tabs-" + tab.id,
            li = jQuery( self.tabTemplate.replace( /#\{href\}/g, "#" + id ).replace( /#\{label\}/g, label ).replace( /\{class\}/g, ((tab.tabdirection === 'rtl')?'text-right':'text-left') + ' ' + tab.tabcss) ),
            textfield_id = id.replace(/\-/g, "") + 'content',
            texteditor = self.textEditorHtml.replace( /\{id\}/g, textfield_id);

            //remove any previous instance of editor with similar id
            if (angular.isObject(tinymce.editors[textfield_id]))
                tinymce.editors[textfield_id].remove();
            
            self.tab.tabs.find( ".ui-tabs-nav li.insert-tab" ).before( li );
            self.tab.tabs.append( "<div id='" + id + "'><div id='" + id + "-content'></div><p><label><input type=\"checkbox\" ng-model=\"categories.showAccordionContent\">Show accordion content</label></p></div>" );
            self.tab.tabs.tabs( "refresh" );

            texteditor = texteditor.replace( /\{content\}/g, ld.stripslashes(tab.tabcontent));
            jQuery("#" + id + "-content").append(texteditor);
            self.create_textEditor(textfield_id);
        });
        self.tab.tabs.tabs('option', 'active', 0);
    };
})
.directive('tabRowsLoaded', function() {
    return function(scope, element, attrs) {
        if (angular.isUndefined(scope.row.id)) {
            scope.row.id = scope.$index + 1;
        }
        scope.row.tabname = ld.stripslashes(scope.row.tabname);

    };
})
        .directive('categoryRowsLoaded', function() {
    return function(scope, element, attrs) {
        if (angular.isUndefined(scope.row.id)) {
            scope.row.id = scope.$index + 1;
        }
        scope.row.categoryname = ld.stripslashes(scope.row.categoryname);

    };
})
.directive('accordionRowsLoaded', function() {
    return function(scope, element, attrs) {
        if (angular.isUndefined(scope.row.id)) {
            scope.row.id = scope.$index + 1;
        }
        scope.row.accordionname = ld.stripslashes(scope.row.accordionname);

    };
})
        .directive('menuItemsLoaded', function() {
    return function(scope, element, attrs) {
        if (scope.$last) {
            jQuery("#category-menu").menu("destroy");
            jQuery("#category-menu").menu();
        }
    };
})
        .directive('menuContentEditable', function($compile, $rootScope, URI) {
    return {
        link: function(scope, elm, attrs, ctrl) {
            jQuery(elm).hover(function(e) {
                var html = '<div style="position:absolute; background-color: #dedede; padding: 0 10px;">\n\
                                <img src="' + URI + 'images/delete-icon.png" alt="delete category" title="delete category" ng-click="categories.catDelete(' + scope.category.categoryid + ')">\n\
                                <img src="' + URI + 'images/edit-icon.png" alt="edit category" title="edit category" ng-click="categories.edit(' + scope.category.categoryid + ')">\n\
                                <img src="' + URI + 'images/add-icon.png" alt="add subcategory" title="add subcategory" ng-click="categories.showAddCategoriesDialog(' + scope.category.categoryid + ')">\n\
                            ';

                scope.categories = angular.element("#categories").scope().categories;

                //if (angular.isUndefined(scope.category.subcategory)) {
                    html += '<img src="' + URI + 'images/document-icon.png" alt="manage content" title="manage content" ng-click="categories.manageContent(' + scope.category.categoryid + ')">';
                //}

                html += '</div>';

                elm.append(html);
                $compile(elm.contents())(scope);
            }, function(e) {
                jQuery(elm).find('div').remove();
            });
        }
    };
})
        .directive("collection", function() {
    return {
        restrict: "E",
        replace: true,
        scope: {
            collection: '='
        },
        template: "<category bindonce ng-repeat='category in collection track by $index' category='category'></category>"
    };
})
        .directive('category', function($compile) {
    return {
        restrict: "E",
        replace: true,
        scope: {
            category: '='
        },
        template: "<li><a ng-href=\"\" menu-content-editable bo-text='category.categoryname|text' bo-attr bo-attr-class=\"((category.categorydirection === 'rtl')?'text-right':'text-left') + ' ' + category.categorycss\"></a></li>",
        link: function(scope, element, attrs) {
            if (angular.isDefined(scope.category.subcategory)) {
                element.append("<ul><collection collection='category.subcategory' menu-items-loaded></collection></ul>");
                $compile(element.contents())(scope);
            }

        }
    };
});