/* 
 * 
 * @author Zishan J.
 */

catalog.controller('Settings', function(NONCE, $timeout, $http) {
    this.statusMessage = "";
    this.disable_jqueryui_css = (catalogData.disable_jqueryui_css === 'true')?true:false;
    this.disable_bootstrap_css = (catalogData.disable_bootstrap_css === 'true')?true:false;
	this.email_from = catalogData.email_from;
	this.email_address = catalogData.email_address;
    this.email_subject = catalogData.email_subject;
    this.email_template = catalogData.email_template;
    this.fb_app_id = catalogData.fb_app_id;
    this.fb_media_type = catalogData.fb_media_type;
    this.fb_image = catalogData.fb_image;
    
    var self = this;
    
    this.save = function save() {
        jQuery.showStatusDialog({'message': 'Saving settings&hellip;'});
        
        var data = {
            action: 'gicatalog_save_settings',
            setting: {
                disable_jqueryui_css: self.disable_jqueryui_css,
                disable_bootstrap_css: self.disable_bootstrap_css, 
                fb_app_id: jQuery.trim(self.fb_app_id),
                fb_media_type: jQuery.trim(self.fb_media_type),
                fb_image: jQuery.trim(self.fb_image),
				email_from: jQuery.trim(self.email_from),
				email_address: jQuery.trim(self.email_address),
                email_subject: jQuery.trim(self.email_subject), 
                email_template: jQuery.trim(self.email_template)
            },
            _ajax_nonce: NONCE
        };

        $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
            if (response.data.success){
                
            }else{

            }
            self.statusMessage = response.data.message;
            jQuery.scrollTo('#settings-message', 800, {offset: -35});
            jQuery.showStatusDialog({show: false});
        }, function(rejectReason) {
            console.log("request error");
            console.dir(rejectReason);
        });
    };
});