'use strict';

catalog.controller('Shortcode', function($compile, $timeout, $http, URI, NONCE) {
    this.showLoader = false;
    this.setAsDefault = false;
    this.showSearchBar = true;
    this.showPagination = true;
    this.itemsPerPage = 5;
    this.collapsibleAccordion = false;
    this.hideSingleTabHeader = false;
    this.uri = URI;
    this.group = {};
    this.group.data = [];
    this.group.selected = [];
    this.category = {};
    this.category.data = [];
    this.category.selected = [];
    
    var self = this;
    
	jQuery('#gicatalog-shortcode').dialog({
		open: function(e) {
			self.showLoader = true;
			var data = {
				action: 'gicatalog_get_groups',
				_ajax_nonce: NONCE
			};

			$http.post(ajaxurl, jQuery.param(data)).then(function(response) {
				if (response.data.success) {
					self.group.data = response.data.data.groups;
					self.category.data = response.data.data.categories;
					if (self.group.data.length>0) {
						self.group.selected = self.group.data[0];
					}
					if (self.category.data.length>0) {
						self.category.selected = self.category.data[0];
					}
				} else {

				}
				$timeout(function() {
					self.showLoader = false;
				});
			}, function(rejectReason) {
				//self.showAddCategoriesDialog();
				console.log("request error");
				console.dir(rejectReason);
			});
		}
	});
	
    this.group.change = function group_change() {
        self.showLoader = true;
        var data = {
            action: 'gicatalog_get_categories',
            groupid: self.group.selected['groupid'],
            _ajax_nonce: NONCE
        };
        $http.post(ajaxurl, jQuery.param(data)).then(function(response) {
            if (response.data.success) {
                self.category.data = response.data.data;
                self.category.selected = [];
                if (self.category.data.length>0) {
                    self.category.selected = self.category.data[0];
                }
            } else {

            }
            $timeout(function() {
                self.showLoader = false;
            });
        }, function(rejectReason) {
            //self.showAddCategoriesDialog();
            console.log("request error");
            console.dir(rejectReason);
        });
    };
    
    this.add = function shortcode_add() {
        tinymce.editors['content'].selection.setContent('[gi_catalog id="' + self.category.selected['categoryid'] + '" \n\
                                                        default="' + self.setAsDefault + '" \n\
                                                        show_search_bar="' + self.showSearchBar + '" \n\
                                                        show_pagination="' + self.showPagination + '" \n\
                                                        items_per_page="' + self.itemsPerPage + '" \n\
                                                        collapsible_accordion="' + self.collapsibleAccordion + '" \n\
                                                        hide_singletab_header="' + self.hideSingleTabHeader + '"]');
    };
});