<script>
    /*
     *			Author: Zishan J.
     *			
     *
     */
    jQuery(function($) {
        $.showStatusDialog = function(options) {
            var defaults = {
                showImage: true,
                show: true,
                message: ''
                };
            var merged_options = $.extend({}, defaults, options);

            if (merged_options.showImage) {
                $( 'div#statusdialog' ).find('img').show();
            }else{
                $( 'div#statusdialog' ).find('img').hide();
            }
            if (merged_options.message != '') {
                $( 'div#statusdialog' ).find( 'span' ).html(merged_options.message);
            }
            if (merged_options.show) {
                $( 'div#statusdialog' ).dialog('open');
            }else{
                setTimeout(function(){
                    $( 'div#statusdialog' ).dialog('close');
                },1000);
            }
        };
        $( "#category-menu" ).menu();
        $( 'div#statusdialog' ).dialog({
            draggable: false,
            resizable: false,
            modal: true,
            minWidth: false,
            minHeight: false,
            width: "auto",
            autoOpen: false
        });
        $(".ui-dialog-titlebar").hide();
        $(window).resize(function() {
            $("div#statusdialog").dialog("option", "position", "center");
        });
        
    });
</script>
<div ng-app="GI-Catalog">
<div class="clear"></div>
<div id="statusdialog" style="-webkit-box-shadow: 2px 2px 5px #888; -moz-box-shadow: 2px 2px 5px #888; padding: 5px;">
    <div class="col"><img src="<?php echo GICATALOG_URI . 'images/ajax-loader.gif'; ?>" style="display:none;" alt="loading" id="loading" /></div>
    <div class="col-right"><span style="font-size: 20px; line-height:37px"></span></div>
    <div class="clear"></div>
</div>
<div id="categories-message" style="display: none;"></div>
<div class="accordion-container">
    <ul class="outer-border">
        <li class="control-section accordion-section <?php echo ($menu === 'groups') ? 'open' : '' ?>" ng-controller="Groups as groups">
            <h3 class="accordion-section-title hndle" tabindex="0" title="Groups">Groups</h3>
            <div class="accordion-section-content">
                <div class="inside">
                        <div id="col-container">
                            <div id="col-right">
                                <div class="col-wrap">
                                    <div class="form-row">
                                        <div class="col">
                                            <label for="selectgroups">Select Groups:</label><br />
                                            <select class="postform" style="min-width:13em; max-width:22em;" id="selectgroups" name="selectgroups" multiple="multiple" ng-model="groups.group" ng-options="group.name | text for group in groups.data track by group.groupid"></select>
                                        </div>
                                        <div class="col">
                                            <input type="button" class="button" value="Edit" ng-disabled="groups.group.length == 0" ng-click="groups.edit()"/>
                                            <input type="button" class="button" value="Delete" ng-disabled="(groups.group.length == 0 || groups.isEditMode)" ng-click="groups.grpDelete()"/>
                                        </div>
                                        <div class="clear"></div>
                                    </div>
                                    <div class="form-row">
                                        <div class="form-wrap col">
                                            <p>
                                                <strong>Note:</strong><br/>
                                                Deleting a group will also delete all it's categories.
                                            </p>
                                        </div>
                                        <div class="clear"></div>
                                    </div>
                                </div>
                            </div>
                            <div id="col-left">
                                <div class="col-wrap">
                                    <div class="rowentries">
                                        <div bindonce ng-repeat="row in groups.rows track by $index" class="form-row repeated-item" group-rows-loaded>
                                            <div class="col"><strong bo-text="row.id + '.'"></strong></div>
                                            <div class="col"><label bo-attr bo-attr-for="'groupname' + row.id"><font color="#FF0000">*</font>Name:</label><br><textarea bo-id="'groupname' + row.id" ng-model="row.name"></textarea></div>
                                            <div class="col"><label bo-attr bo-attr-for="'groupcss' + row.id">CSS:</label><br><input class="small-text" bo-id="'groupcss' + row.id" type="text" ng-model="row.css"></div>
                                            <div class="col">
                                                <label bo-attr bo-attr-for="'groupdirection' + row.id">Direction:</label><br>
                                                <select bo-id="'groupdirection' + row.id" ng-model="row.direction">
                                                    <option value="ltr">LTR</option>
                                                    <option value="rtl">RTL</option>
                                                </select>
                                            </div>
                                            <div class="col">
                                                <div class="remove-row">
                                                    <p>
                                                        <img src="<?php echo GICATALOG_URI . 'images/delete-icon.png'; ?>" alt="remove row" title="remove row" ng-show="groups.rows.length > 1" ng-click="groups.removeRow(row.id)">
                                                    </p>
                                                </div>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                    </div>
                                    <div class="form-row" ng-hide="groups.isEditMode">
                                        <div class="insert-row">
                                            <p><span ng-click="groups.insertRow()"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="insert row" title="insert row">&nbsp;insert row</span></p>
                                        </div>
                                    </div>
                                    <div class="form-row">
                                        <input type="button" class="button button-primary" ng-value="(groups.isEditMode)?'Update':'Add'" id="btngroupadd" name="btngroupadd" ng-disabled="groups.rows.length == 0" ng-click="groups.update()"/>
                                        <input type="button" class="button" value="Cancel" id="btncategorycancel" name="btncategorycancel" ng-click="groups.cancel()" ng-show="groups.isEditMode"/>
                                    </div>
                                </div>
                            </div>
                        </div>
                    <br class="clear"/>
                </div>
            </div>
        </li>
        <li id="categories" class="control-section accordion-section <?php echo ($menu === 'categories') ? 'open' : '' ?>" ng-controller="Categories as categories">
            <h3 class="accordion-section-title hndle" tabindex="0" title="Categories & Contents">Categories & Contents</h3>
<!--            <div id="create-categories" style="display:none">
                <div class="form-row">
                    <div class="rowentries">
                        <div bindonce ng-repeat="row in categories.rows track by $index" class="form-row repeated-item" categories-loaded>
                            <div class="col"><strong bo-text="row.id + '.'"></strong></div>
                            <div class="col"><label bo-attr bo-attr-for="'categoryname' + row.id"><font color="#FF0000">*</font>Name:</label><br><textarea bo-id="'categoryname' + row.id" ng-model="row.name"></textarea></div>
                            <div class="col"><label bo-attr bo-attr-for="'categorycss' + row.id">CSS:</label><br><input class="small-text" bo-id="'categorycss' + row.id" type="text" ng-model="row.css"></div>
                            <div class="col">
                                <label bo-attr bo-attr-for="'categorydirection' + row.id">Direction:</label><br>
                                <select bo-id="'categorydirection' + row.id" ng-model="row.direction">
                                    <option value="ltr">LTR</option>
                                    <option value="rtl">RTL</option>
                                </select>
                            </div>
                            <div class="col">
                                <div class="remove-row">
                                    <p>
                                        <img src="<?php echo GICATALOG_URI . 'images/delete-icon.png'; ?>" alt="remove row" title="remove row" ng-click="categories.removeRow(row.id)">
                                    </p>
                                </div>
                            </div>
                            <div class="clear"></div>
                        </div>
                    </div>
                </div>
                <div class="form-row" ng-hide="categories.isEditMode">
                    <div class="insert-row">
                        <p><span ng-click="categories.insertRow()"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="insert row" title="insert row">&nbsp;insert row</span></p>
                    </div>
                </div>
                <div class="form-row">
                    <input type="button" class="button button-primary" ng-value="(categories.isEditMode)?'Update':'Add'" ng-disabled="categories.rows.length == 0" ng-click="categories.update()"/>
                    <input type="button" class="button" value="Cancel" ng-click="categories.cancel()" ng-show="categories.isEditMode"/>
                </div>
            </div>-->
            <div class="accordion-section-content">
                <div class="inside">
                        <div id="col-container">
                                <div id="col-right">
                                    <div class="col-wrap">
<!--                                        <div class="form-row">
                                            <div class="col">
                                                <label for="selectcategories">Select Categories:</label><br />
                                                <select class="postform" style="min-width:13em" id="selectcategories" name="selectcategories" multiple="multiple" ng-model="categories.category" ng-options="category.name for category in categories.data track by category.categoryid"></select>
                                            </div>
                                            <div class="col">
                                                <input type="button" class="button" value="Edit" ng-disabled="categories.category.length == 0" ng-click="categories.edit()"/>
                                                <input type="button" class="button" value="Delete" ng-disabled="(categories.category.length == 0 || categories.isEditMode)" ng-click="categories.catDelete()"/>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                        <div class="form-row">
                                            <div class="form-wrap col">
                                                <p>
                                                    <strong>Note:</strong><br/>
                                                    Deleting a category will also delete all its contents.
                                                </p>
                                            </div>
                                            <div class="clear"></div>
                                        </div>-->
                                        <div class="form-row">
                                            <div class="col">
                                                <label for="selectcategorygroup">Select Group:</label><br />
                                                <select class="postform" style="min-width:13em; max-width:22em;" id="selectcategorygroup" name="selectcategorygroup" ng-change="categories.group.change()" ng-model="categories.group.selected" ng-options="group.name | text for group in categories.group.data track by group.groupid"></select>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                        <div class="form-row">
                                            <div class="col">
                                                <div class="category-menu">
                                                    <ul id="category-menu">
                                                        <collection collection="categories.data" menu-items-loaded></collection>
    <!--                                                    <li bindonce ng-repeat="category in categories.data track by category.categoryid" class="repeated-item" menu-items-loaded><a ng-href="" menu-content-editable bo-text="category.name"></a></li>-->
    <!--                                                    <li><a ng-href="" menu-content-editable ng-model="category2">Adamsville</a></li>
                                                        <li><a ng-href="" menu-content-editable ng-model="category3">Addyston</a></li>
                                                        <li>
                                                          <a href="" menu-content-editable>Delphi</a>
                                                          <ul>
                                                            <li class="ui-state-disabled"><a href="" menu-content-editable>Ada</a></li>
                                                            <li><a href="" menu-content-editable>Saarland</a></li>
                                                            <li><a href="" menu-content-editable>Salzburg</a></li>
                                                          </ul>
                                                        </li>
                                                        <li><a href="#">Saarland</a></li>
                                                        <li>
                                                          <a href="#">Salzburg</a>
                                                          <ul>
                                                            <li>
                                                              <a href="#">Delphi</a>
                                                              <ul>
                                                                <li><a href="#">Ada</a></li>
                                                                <li><a href="#">Saarland</a></li>
                                                                <li><a href="#">Salzburg</a></li>
                                                              </ul>
                                                            </li>
                                                            <li>
                                                              <a href="#">Delphi</a>
                                                              <ul>
                                                                <li><a href="#">Ada</a></li>
                                                                <li><a href="#">Saarland</a></li>
                                                                <li><a href="#">Salzburg</a></li>
                                                              </ul>
                                                            </li>
                                                            <li><a href="#">Perch</a></li>
                                                          </ul>
                                                        </li>
                                                        <li class="ui-state-disabled"><a href="#">Amesville</a></li>-->
                                                    </ul>
                                                    <div class="insert-row"><p><span ng-click="categories.showAddCategoriesDialog()" ng-show="categories.group.selected"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="add item" title="add item">&nbsp;add item</span></p></div>
                                                </div>
                                            </div>
                                            <div class="clear"></div>
                                        </div>
                                        <div class="form-row">
                                            <div class="col">
                                                <p>
                                                    <strong>Note:</strong><br/>
                                                    Deleting a category will also delete all it's sub-categories and contents.
                                                </p>
                                            </div>
                                        <div class="clear"></div>
                                    </div>
                                    </div>
                                </div>
                                <div id="col-left">
                                    <div class="col-wrap">
                                        <div id="create-categories" ng-show="categories.isInsertMode || categories.isEditMode">
                                            <div class="form-row">
                                                <div class="rowentries">
                                                    <div bindonce ng-repeat="row in categories.rows track by $index" class="form-row repeated-item" category-rows-loaded>
                                                        <div class="col"><strong bo-text="row.id + '.'"></strong></div>
                                                        <div class="col"><label bo-attr bo-attr-for="'categoryname' + row.id"><font color="#FF0000">*</font>Name:</label><br><textarea bo-id="'categoryname' + row.id" ng-model="row.categoryname"></textarea></div>
                                                        <div class="col"><label bo-attr bo-attr-for="'categorycss' + row.id">CSS:</label><br><input class="small-text" bo-id="'categorycss' + row.id" type="text" ng-model="row.categorycss"></div>
                                                        <div class="col">
                                                            <label bo-attr bo-attr-for="'categorydirection' + row.id">Direction:</label><br>
                                                            <select bo-id="'categorydirection' + row.id" ng-model="row.categorydirection">
                                                                <option value="ltr">LTR</option>
                                                                <option value="rtl">RTL</option>
                                                            </select>
                                                        </div>
                                                        <div class="col"><label bo-attr bo-attr-for="'categorysortorder' + row.id">Sort Order:</label><br><input class="small-text" bo-id="'categorysortorder' + row.id" type="text" ng-model="row.categorysortorder"></div>
                                                        <div class="col">
                                                            <div class="remove-row">
                                                                <p>
                                                                    <img src="<?php echo GICATALOG_URI . 'images/delete-icon.png'; ?>" alt="remove row" title="remove row" ng-show="categories.rows.length > 1" ng-click="categories.removeRow(row.id)">
                                                                </p>
                                                            </div>
                                                        </div>
                                                        <div class="clear"></div>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="form-row" ng-hide="categories.isEditMode">
                                                <div class="insert-row">
                                                    <p><span ng-click="categories.insertRow()"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="insert row" title="insert row">&nbsp;insert row</span></p>
                                                </div>
                                            </div>
                                            <div class="form-row">
                                                <input type="button" class="button button-primary" ng-value="(categories.isEditMode)?'Update':'Add'" ng-disabled="categories.rows.length == 0" ng-click="categories.update()"/>
                                                <input type="button" class="button" value="Cancel" ng-click="categories.cancel()" ng-show="categories.isEditMode"/>
                                            </div>
                                        </div>
                                        <div ng-show="categories.isManageContent">
                                            <div id="main-content" class="form-row"></div>
                                            <div class="form-row">
                                                <label><input type="checkbox" ng-model="categories.showTabbedContent">Show tabbed content</label>
                                            </div>
                                            <div ng-show="categories.showTabbedContent" class="form-row">
                                                <div>
                                                    <p><strong>Note:</strong> Drag the tabs to re-order them.</p>
                                                </div>
                                                <gi-tabs tab-id="managecontent-tabs" collection="categories.tab.data"></gi-tabs>
                                                    
                                            </div>
                                            <div class="form-row">
                                                <input type="button" class="button button-primary" value="Save" ng-click="categories.save()"/>
                                            </div>
                                            <div id="create-tabs" style="display:none">
                                                <div class="form-row">
                                                    <div class="rowentries">
                                                        <div bindonce ng-repeat="row in categories.tab.rows track by $index" class="form-row repeated-item" tab-rows-loaded>
                                                            <div class="col"><strong bo-text="($index + 1) + '.'"></strong></div>
                                                            <div class="col"><label bo-attr bo-attr-for="'tabname' + ($index + 1)"><font color="#FF0000">*</font>Name:</label><br><textarea bo-id="'tabname' + ($index + 1)" ng-model="row.tabname"></textarea></div>
                                                            <div class="col"><label bo-attr bo-attr-for="'tabcss' + ($index + 1)">CSS:</label><br><input class="small-text" bo-id="'tabcss' + ($index + 1)" type="text" ng-model="row.tabcss"></div>
                                                            <div class="col">
                                                                <label bo-attr bo-attr-for="'tabdirection' + ($index + 1)">Direction:</label><br>
                                                                <select bo-id="'tabdirection' + ($index + 1)" ng-model="row.tabdirection">
                                                                    <option value="ltr">LTR</option>
                                                                    <option value="rtl">RTL</option>
                                                                </select>
                                                            </div>
                                                            <div class="col">
                                                                <div class="remove-row">
                                                                    <p>
                                                                        <img src="<?php echo GICATALOG_URI . 'images/delete-icon.png'; ?>" alt="remove row" title="remove row" ng-show="categories.tab.rows.length > 1" ng-click="categories.tab.removeRow(row.id)">
                                                                    </p>
                                                                </div>
                                                            </div>
                                                            <div class="clear"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="form-row" ng-hide="categories.tab.isEditMode">
                                                    <div class="insert-row">
                                                        <p><span ng-click="categories.tab.insertRow()"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="insert row" title="insert row">&nbsp;insert row</span></p>
                                                    </div>
                                                </div>
                                                <div class="form-row">
                                                    <input type="button" class="button button-primary" ng-value="(categories.tab.isEditMode)?'Update':'Add'" ng-disabled="categories.tab.rows.length == 0" ng-click="categories.tab.update()"/>
                                                    <input type="button" class="button" value="Cancel" onclick="tb_remove()" ng-show="categories.tab.isEditMode"/>
                                                </div>
                                            </div>
                                            <div id="create-accordions" style="display:none">
                                                <div class="form-row">
                                                    <div class="rowentries">
                                                        <div bindonce ng-repeat="row in categories.accordion.rows track by $index" class="form-row repeated-item" accordion-rows-loaded>
                                                            <div class="col"><strong bo-text="($index + 1) + '.'"></strong></div>
                                                            <div class="col"><label bo-attr bo-attr-for="'accordionname' + ($index + 1)"><font color="#FF0000">*</font>Name:</label><br><textarea bo-id="'accordionname' + ($index + 1)" ng-model="row.accordionname"></textarea></div>
                                                            <div class="col"><label bo-attr bo-attr-for="'accordioncss' + ($index + 1)">CSS:</label><br><input class="small-text" bo-id="'accordioncss' + ($index + 1)" type="text" ng-model="row.accordioncss"></div>
                                                            <div class="col">
                                                                <label bo-attr bo-attr-for="'accordiondirection' + ($index + 1)">Direction:</label><br>
                                                                <select bo-id="'accordiondirection' + ($index + 1)" ng-model="row.accordiondirection">
                                                                    <option value="ltr">LTR</option>
                                                                    <option value="rtl">RTL</option>
                                                                </select>
                                                            </div>
                                                            <div class="col">
                                                                <div class="remove-row">
                                                                    <p>
                                                                        <img src="<?php echo GICATALOG_URI . 'images/delete-icon.png'; ?>" alt="remove row" title="remove row" ng-show="categories.accordion.rows.length > 1" ng-click="categories.accordion.removeRow(row.id)">
                                                                    </p>
                                                                </div>
                                                            </div>
                                                            <div class="clear"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="form-row" ng-hide="categories.accordion.isEditMode">
                                                    <div class="insert-row">
                                                        <p><span ng-click="categories.accordion.insertRow()"><img src="<?php echo GICATALOG_URI . 'images/add-icon.png'; ?>" alt="insert row" title="insert row">&nbsp;insert row</span></p>
                                                    </div>
                                                </div>
                                                <div class="form-row">
                                                    <input type="button" class="button button-primary" ng-value="(categories.accordion.isEditMode)?'Update':'Add'" ng-disabled="categories.accordion.rows.length == 0" ng-click="categories.accordion.update()"/>
                                                    <input type="button" class="button" value="Cancel" onclick="tb_remove()" ng-show="categories.accordion.isEditMode"/>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            
                        </div>
                    <br class="clear"/>
                </div>
            </div>
        </li>
    </ul>
</div>
</div>