<!--

@author Zishan J.

-->
<script>
    jQuery(function ($) {
        $.showStatusDialog = function (options) {
            var defaults = {
                showImage: true,
                show: true,
                message: ''
            };
            var merged_options = $.extend({}, defaults, options);

            if (merged_options.showImage) {
                $('div#statusdialog').find('img').show();
            } else {
                $('div#statusdialog').find('img').hide();
            }
            if (merged_options.message != '') {
                $('div#statusdialog').find('span').html(merged_options.message);
            }
            if (merged_options.show) {
                $('div#statusdialog').dialog('open');
            } else {
                setTimeout(function () {
                    $('div#statusdialog').dialog('close');
                }, 1000);
            }
        };
        $('div#statusdialog').dialog({
            draggable: false,
            resizable: false,
            modal: true,
            minWidth: false,
            minHeight: false,
            width: "auto",
            autoOpen: false
        });
        $(".ui-dialog-titlebar").hide();
        $(window).resize(function () {
            $("div#statusdialog").dialog("option", "position", "center");
        });

    });
</script>
<div ng-app="GI-Catalog">
    <div class="clear"></div>
    <div id="statusdialog" style="-webkit-box-shadow: 2px 2px 5px #888; -moz-box-shadow: 2px 2px 5px #888; padding: 5px;">
        <div class="col"><img src="<?php echo GICATALOG_URI . 'images/ajax-loader.gif'; ?>" style="display:none;" alt="loading" id="loading" /></div>
        <div class="col-right"><span style="font-size: 20px; line-height:37px"></span></div>
        <div class="clear"></div>
    </div>
    <div ng-controller="Settings as setting">
        <div id="settings-message" ng-bind-html="setting.statusMessage|html"></div>
        <h3 class="title">General</h3>
        <table class="form-table">
            <tr>
                <th scope="row">Formatting</th>
                <td>
                    <fieldset><legend class="screen-reader-text"><span>Formatting</span></legend>
                        <label for="disable-jqueryui-css">
                            <input name="disable-jqueryui-css" type="checkbox" id="disable-jqueryui-css" ng-model="setting.disable_jqueryui_css">
                            Disable jQuery UI CSS</label>
                        <p class="description">You can disable plugin jQuery UI CSS if you are using similar jQuery UI CSS file with your template to avoid overriding.</p><br/>
                        <label for="disable-bootstrap-css">
                            <input name="disable-bootstrap-css" type="checkbox" id="disable-bootstrap-css" ng-model="setting.disable_bootstrap_css">
                            Disable Bootstrap CSS</label>
                        <p class="description">You can disable plugin Bootstrap CSS if you are using similar Bootstrap CSS file with your template to avoid overriding.</p>
                    </fieldset>
                </td>
            </tr>
        </table>
        <h3 class="title">Facebook Share</h3>
        <table class="form-table">
            <tr>
                <th scope="row"><label for="fb-app-id">App ID</label></th>
                <td><input name="fb-app-id" type="text" id="fb-app-id" ng-model="setting.fb_app_id" class="regular-text code"></td>
            </tr>
            <tr>
                <th scope="row"><label for="fb-media-type">Media Type (og:type)</label></th>
                <td><input name="fb-media-type" type="text" id="fb-media-type" ng-model="setting.fb_media_type" class="regular-text code"></td>
            </tr>
            <tr>
                <th scope="row"><label for="fb-image">Image URL (og:image)</label></th>
                <td>
                    <input name="fb-image" type="text" id="fb-image" ng-model="setting.fb_image" class="regular-text code">
                    <p class="description">Facebook suggested that an image should be at least 1200x630 pixels.</p>
                </td>
            </tr>
        </table>
        <h3 class="title">Share via Email</h3>
        <p>Following settings will be used when user will share the accordion content via email.</p>
        <table class="form-table">
            <tr>
                <th scope="row"><label for="email-from">Email From</label></th>
                <td><input name="email-from" type="text" id="email-from" ng-model="setting.email_from" class="regular-text code"></td>
            </tr>
            <tr>
                <th scope="row"><label for="email-address">Email From Address</label></th>
                <td><input name="email-address" type="text" id="email-address" ng-model="setting.email_address" class="regular-text code"></td>
            </tr>
            <tr>
                <th scope="row"><label for="email-subject">Email Subject</label></th>
                <td><input name="email-subject" type="text" id="email-subject" ng-model="setting.email_subject" class="regular-text code"></td>
            </tr>
            <tr>
                <th scope="row"><label for="email-template">Email Template</label></th>
                <td>
                    <textarea name="email-template" id="email-template" class="large-text code" rows="10" ng-model="setting.email_template"></textarea>
                    <p class="description">[HEADER] and [CONTENT] are required placeholders.</p>
                </td>
            </tr>
        </table>
        <p class="submit"><input type="button" name="submit" id="submit" class="button button-primary" value="Save Changes" ng-click="setting.save()"></p>
    </div>
</div>