'use strict';

catalog.directive('giAccordions', function($timeout, $rootScope, COLLAPSIBLE_ACCORDION, ITEM_ID, QUERY_ITEM_URL, TEMPLATE_URI, ITEMS_PER_PAGE, SHOW_PAGINATION) {
        return {
            restrict: "E",
            replace: true,
            scope: {
                tabId: '@',
                accordionId: '@',
                accordionCategoryId: '=',
                accordionCollection: '='
            },
            controller: function($scope) {
                    
                
            },
            templateUrl: TEMPLATE_URI + 'accordion.html',
            link: function(scope, element, attrs) {
                
                var data = angular.copy(scope.accordionCollection);
                //search event
                scope.search = false;
                scope.$on('gicatalog.accordion.search', function(e, newdata) {
                    scope.collection = [];
                    scope.search = true;
                    scope.showAccordionContent = true;
                    scope.showPagination = true;
                    scope.totalPages = 0;
                    scope.currentPage = 0;
                    if (ld.isNull(newdata)) {
                        scope.showAccordionContent = false;
                        scope.showPagination = false;
                        return;
                    }
                    data = newdata;
                    scope.totalPages = Math.ceil(data.accordions.length/ITEMS_PER_PAGE);
                    scope.pages = ld.range(1, scope.totalPages + 1);
                    scope.nextPage(1);
                });
                
                
                scope.collection = [];
                scope.showAccordionContent = false;
                scope.showLinkIcon = false;
                scope.showEmailIcon = false;
                scope.showShareIcon = false;
                scope.showPagination = false;
                scope.totalPages = 0;
                scope.currentPage = 0;
                scope.queryItemURL = QUERY_ITEM_URL;
                
                scope.sendEmail = function sendEmail(header, content) {
                    $rootScope.$broadcast('gicatalog.share_email.update', header, content);
                    jQuery('#gicatalog-share-email-dialog').modal('show');
                };
                scope.copyLink = function copyLink(id) {
                    return (scope.search)?(QUERY_ITEM_URL + '=' + id):(QUERY_ITEM_URL + '=' + scope.accordionCategoryId + '-' + scope.tabId + '-' + id);
                };
                scope.afterCopyLink = function afterCopyLink() {
                    alert("Link copied to your clipboard. Use 'Ctrl + V' on Windows or 'Command + V' on Mac to paste the link.");
                };
                
                scope.findDataPage = function findDataPage(id) {
                    var defaultid = 0;
                    angular.forEach(data.accordions, function(val, key){
                        if (val.id == id) {
                            defaultid = key + 1;
                        }
                        val['default'] = (val.id == id);
                    });
                    
                    return (scope.showPagination)?Math.ceil(defaultid/ITEMS_PER_PAGE):1;
                };
                
                scope.nextPage = function nextPage(currPage) {
                    if (currPage == scope.currentPage) return;
                        
                    var upperBound = ITEMS_PER_PAGE * currPage - 1;
                    var lowerBound = Math.abs(ITEMS_PER_PAGE * currPage - ITEMS_PER_PAGE);
                    var tmp = [];
                    for (var i=lowerBound; i<=upperBound; i++) {
                        if (angular.isObject(data.accordions[i]))
                            tmp.push(data.accordions[i]);
                    }
                    
                    scope.collection = tmp;
                    scope.currentPage = currPage;
                    
                    $timeout(function(){
                        jQuery( "#" + scope.accordionId + scope.tabId ).accordion({
                            header: "> div > h3",
                            heightStyle: "content"
                        });

                        jQuery( "#" + scope.accordionId + scope.tabId ).accordion("refresh");

                        if (COLLAPSIBLE_ACCORDION) {
                            jQuery( "#" + scope.accordionId + scope.tabId ).accordion( "option", {collapsible: COLLAPSIBLE_ACCORDION, active: false});
                        }

                        var id = jQuery( "#" + scope.accordionId + scope.tabId + " > div" ).index(jQuery('#' + scope.accordionId + scope.tabId + ' > div[aria-default="true"]'));
                        jQuery( "#" + scope.accordionId + scope.tabId ).accordion( "option", {active: (id < 0)?(COLLAPSIBLE_ACCORDION?false:0):id});
                        
                        $rootScope.$broadcast('gicatalog.accordions.loaded');

                    });
                };
                
                if (angular.isDefined(data)) {
                    if (angular.isDefined(data.accordions)) {
                        scope.showLinkIcon = (data.showlinkicon === "true");
                        scope.showEmailIcon = (data.showemailicon === "true");
                        scope.showShareIcon = (data.showshareicon === "true");
                        scope.showAccordionContent = (data.showaccordioncontent === "true" && data.accordions.length>0);
                        scope.showPagination = (scope.showAccordionContent && SHOW_PAGINATION);

                        var currPage = 1;
                        if (!ld.isEmpty(ITEM_ID)) {
                            if (scope.tabId == parseInt(ITEM_ID.split("-")[2])) {
                               currPage = scope.findDataPage(parseInt(ITEM_ID.split("-")[3]));
                            }
                        }

                        if (scope.showPagination) {
                            scope.totalPages = Math.ceil(data.accordions.length/ITEMS_PER_PAGE);
                            scope.pages = ld.range(1, scope.totalPages + 1);
                            scope.nextPage(currPage);
                        }else{
                            scope.collection = data.accordions;
                        }
                    }
                }
            }
        };
    })
    .directive('accordionItemsLoaded', function($timeout, $rootScope, ITEM_ID, COLLAPSIBLE_ACCORDION) {
        return function(scope, element, attrs) {
            
            /*if (!ld.isEmpty(ITEM_ID)) {
                if (scope.tabId == parseInt(ITEM_ID.split("-")[2])) {
                    var accordionid = parseInt(ITEM_ID.split("-")[3]);
                    scope.default = (scope.accordion.id == accordionid);
                }
            }*/
            
            if (scope.$last) {
                
            }
            
        };
    });