'use strict';

catalog.directive('giTabs', function($compile, $timeout, TEMPLATE_URI, HIDE_SINGLETAB_HEADER) {
        return {
            restrict: "E",
            replace: true,
            scope: {
                tabId: '@',
                collection: '=',
                tabCategoryId: '='
            },
            templateUrl: TEMPLATE_URI + 'tab.html',
            link: function(scope, element, attrs) {
                scope.default = false;
                scope.hideSingleTabHeader = (HIDE_SINGLETAB_HEADER && scope.collection.length==1);
            }
        };
    })
    .directive('tabItemsLoaded', function($timeout, $rootScope, ITEM_ID) {
        return function(scope, element, attrs) {
            if (!ld.isEmpty(ITEM_ID)) {
                var tabid = parseInt(ITEM_ID.split("-")[2]);
                scope.default = (scope.tab.id == tabid);
            }
            if (scope.$last) {
                $timeout(function(){
                    if (!scope.hideSingleTabHeader) {
                        var jTab = jQuery( "#" + scope.tabId ).tabs();

                        jTab.tabs("refresh");
                        
                        var id = jQuery( "#" + scope.tabId + " > ul > li" ).index(jQuery('#' + scope.tabId + ' > ul > li[aria-default="true"]'));
                        jTab.tabs( "option", "active", (id < 0)?0:id);
                        
                    }
                    $rootScope.$broadcast('gicatalog.tabs.loaded');
                });
            }
        };
    });