'use strict';

catalog.controller('Shortcode', function($scope, $window, $rootScope, $timeout, $http, URI, SHOW_SEARCH_BAR, CATEGORY_DATA, AJAX_URL, NONCE) {
    this.cat = {};
    this.cat.data = CATEGORY_DATA;
    this.cat.showTabbedContent = angular.isObject(this.cat.data.categorycontent)?(this.cat.data.categorycontent.showtabbedcontent==="true"):false;
    this.tab = {};
    this.tab.data = angular.isObject(this.cat.data.categorycontent)?this.cat.data.categorycontent.tabs:[];
    this.content = angular.isObject(this.cat.data.categorycontent)?this.cat.data.categorycontent.content:'';
    this.showSearchBar = (SHOW_SEARCH_BAR && this.cat.showTabbedContent);
    this.searchMode = false;
    this.search = "";
    this.showLoader = false;
    this.loaderText = "";
    this.uri = URI;
    //for email form
    this.shareEmail = {};
    this.shareEmail.addresses = "";
    this.shareEmail.invalid = false;
    this.shareEmail.empty = true;
    this.shareEmail.success = false;
    this.shareEmail.showLoader = false;
    this.shareEmail.loaderText = "Sending email&hellip;";
    this.shareEmail.statusMessage = "";
        
    var self = this;
    
    jQuery('#gicatalog-share-email-dialog').modal({
        backdrop: 'static',
        keyboard: false,
        show: false
    });
    
    this.contentLoaded = function contentLoaded(e) {
        if (jQuery('.wp-audio-shortcode, .wp-video-shortcode').length > 0) {
            /*
             * codes taken from /wp-includes/js/mediaelement/wp-mediaelement.js?ver=3.9.2
             * mime-types are already added because this mediaelement file is automatically loaded by WP
             * but needs to be initialized manually after contents are loaded from database
             */
            // add mime-type aliases to MediaElement plugin support

            //mejs.plugins.silverlight[0].types.push('video/x-ms-wmv');
            //mejs.plugins.silverlight[0].types.push('audio/x-ms-wma');
            var settings = {};

            if ( jQuery( document.body ).hasClass( 'mce-content-body' ) ) {
                    return;
            }

            if ( typeof _wpmejsSettings !== 'undefined' ) {
                    settings.pluginPath = _wpmejsSettings.pluginPath;
            }

            settings.success = function (mejs) {
                    var autoplay = mejs.attributes.autoplay && 'false' !== mejs.attributes.autoplay;
                    if ( 'flash' === mejs.pluginType && autoplay ) {
                            mejs.addEventListener( 'canplay', function () {
                                    mejs.play();
                            }, false );
                    }
            };
            if (angular.isObject(self.jqPlayer)) {
                if (angular.isObject(self.jqPlayer[0])) {
                    angular.forEach(self.jqPlayer[0], function(val, key){
                        val.player.remove();
                    });
                }
            }
            self.jqPlayer = [];
            self.jqPlayer.push(jQuery('.wp-audio-shortcode, .wp-video-shortcode').mediaelementplayer(settings));
        }
    };
    this.accordionsLoaded = function accordionsLoaded(e) {
        self.contentLoaded();
        if (jQuery.trim(catalogData.fb_app_id)!=='' && !angular.isDefined($window.FB)) {
            jQuery('body').prepend('<div id="fb-root"></div>');
            window.fbAsyncInit = function() {
                FB.init({
                    appId: catalogData.fb_app_id,
                    xfbml: false,
                    version: 'v2.1'
                });
                //parse the entire page after init
                FB.XFBML.parse();
            };
            (function(d, s, id) {
                var js, fjs = d.getElementsByTagName(s)[0];
                    if (d.getElementById(id))
                    return;
                    js = d.createElement(s);
                    js.id = id;
                    js.src = "//connect.facebook.net/en_US/sdk.js";
                    fjs.parentNode.insertBefore(js, fjs);
            }(document, 'script', 'facebook-jssdk'));
        } else {
            if (jQuery.trim(catalogData.fb_app_id)!=='')
                FB.XFBML.parse();
        }
    };
    //init player for main content
    self.contentLoaded();
    
    $scope.$on('gicatalog.accordions.loaded', self.accordionsLoaded);
    $scope.$on('gicatalog.tabs.loaded', self.contentLoaded);
    
    $scope.$on('menu.link.click', function(e, catid) {
        self.showLoader = true;
        self.loaderText = "Loading&hellip;";
        self.search = "";
        self.searchMode = false;
                    
        var data = {
            action: 'gicatalog_get_category',
            categoryid: catid,
            _ajax_nonce: NONCE
        };
        
        $http.post(AJAX_URL, jQuery.param(data)).then(function(response) {
            if (response.data.success) {
                self.tab.data = [];
                $timeout(function() {
                    self.cat.data = response.data.data;
                    self.tab.data = angular.isObject(self.cat.data.categorycontent)?self.cat.data.categorycontent.tabs:[];
                    self.cat.showTabbedContent = angular.isObject(self.cat.data.categorycontent)?(self.cat.data.categorycontent.showtabbedcontent==="true"):false;
                    self.content = angular.isObject(self.cat.data.categorycontent)?self.cat.data.categorycontent.content:'';
                    self.showSearchBar = (SHOW_SEARCH_BAR && self.cat.showTabbedContent);
                    self.contentLoaded();
                });
            } else {

            }
            $timeout(function() {
                self.showLoader = false;
            });
        }, function(rejectReason) {
            //self.showAddCategoriesDialog();
            console.log("request error");
            console.dir(rejectReason);
        });
        
    });
    
    this.searchText = function searchText(searchType) {
        if (ld.isEmpty(ld.trim(self.search)))
            return;
        
        self.showLoader = true;
        self.loaderText = "Searching&hellip;";

        var data = {
            action: 'gicatalog_search',
            type: searchType,
            categoryid: self.cat.data.categoryid,
            groupid: self.cat.data.groupid,
            search: self.search,
            _ajax_nonce: NONCE
        };

        $http.post(AJAX_URL, jQuery.param(data)).then(function(response) {
            if (response.data.success) {
                $timeout(function() {
                    $rootScope.$broadcast('gicatalog.accordion.search', response.data.data);
                    self.searchMode = true;
                });
            } else {

            }
            $timeout(function() {
                self.showLoader = false;
            });
        }, function(rejectReason) {
            //self.showAddCategoriesDialog();
            console.log("request error");
            console.dir(rejectReason);
        });

    };
    
    this.shareEmail.validate = function validateEmail() {
        self.shareEmail.empty = (jQuery.trim(self.shareEmail.addresses)==='');
        
        var emails = self.shareEmail.addresses.split(",");
        var isInValid = false;
        angular.forEach(emails, function(value){
            if (!isInValid)
                isInValid = !(/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(jQuery.trim(value)));
            //isInValid = !(/([a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?)$/.test(jQuery.trim(value)));
        });
        //display one error at a time
        self.shareEmail.invalid = (!self.emptyEmail)?isInValid:false;

    };
    //from site/accordion.js
    $scope.$on('gicatalog.share_email.update', function(e, header, content) {
        self.shareEmail.header = header;
        self.shareEmail.content = content;
    });
    this.shareEmail.close = function closeEmail() {
        self.shareEmail.addresses = "";
        self.shareEmail.invalid = false;
        self.shareEmail.empty = true;
        self.shareEmail.success = false;
        self.shareEmail.showLoader = false;
        self.shareEmail.statusMessage = "";
    };
    this.shareEmail.send = function sendEmail() {
        self.shareEmail.success = false;
        self.shareEmail.showLoader = true;
        
        var data = {
            action: 'gicatalog_send_share_email',
            message: {
                to: self.shareEmail.addresses,
                header: ld.stripslashes(self.shareEmail.header), 
                content: ld.stripslashes(self.shareEmail.content)
            },
            _ajax_nonce: NONCE
        };

        $http.post(AJAX_URL, jQuery.param(data)).then(function(response) {
            self.shareEmail.showLoader = false;
            if (response.data.success){
                self.shareEmail.addresses = "";
                self.shareEmail.success = true;
            }else{

            }
            self.shareEmail.statusMessage = response.data.message;
        }, function(rejectReason) {
            console.log("request error");
            console.dir(rejectReason);
        });
        
    };
});